/**
 * <copyright>
 * </copyright>
 *
 * $Id: Call.java,v 1.1 2008/04/09 22:40:59 urs Exp $
 */
package de.urszeidler.eclipse.callchain;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Call</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.urszeidler.eclipse.callchain.Call#getIn <em>In</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Call#getOut <em>Out</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Call#getRes <em>Res</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Call#getLibarys <em>Libarys</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Call#isAllowInterModelReferences <em>Allow Inter Model References</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Call#isContinueAfterErrors <em>Continue After Errors</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Call#getArtifact <em>Artifact</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Call#getEnviorment <em>Enviorment</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Call#isShowSummary <em>Show Summary</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Call#isPrintExecutionTime <em>Print Execution Time</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Call#isDisableAttributeHelperCache <em>Disable Attribute Helper Cache</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.Call#isProfile <em>Profile</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCall()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='noCircularDefinition usesEnviorementLib usesEviorementSuperimposed'"
 * @generated
 */
public interface Call extends Documentable, Callable {
	/**
	 * Returns the value of the '<em><b>In</b></em>' reference list.
	 * The list contents are of type {@link de.urszeidler.eclipse.callchain.Model}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>In</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>In</em>' reference list.
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCall_In()
	 * @model annotation="http://urszeidler.de/m2m.transform link.sourcecontraint='true' link.targetcontraint='not oppositeEnd.oclIsTypeOf(ModelAlias)'"
	 * @generated
	 */
	EList<Model> getIn();

	/**
	 * Returns the value of the '<em><b>Out</b></em>' reference list.
	 * The list contents are of type {@link de.urszeidler.eclipse.callchain.Model}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Out</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Out</em>' reference list.
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCall_Out()
	 * @model
	 * @generated
	 */
	EList<Model> getOut();

	/**
	 * Returns the value of the '<em><b>Res</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Res</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Res</em>' reference.
	 * @see #setRes(AtlRes)
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCall_Res()
	 * @model required="true"
	 * @generated
	 */
	AtlRes getRes();

	/**
	 * Sets the value of the '{@link de.urszeidler.eclipse.callchain.Call#getRes <em>Res</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Res</em>' reference.
	 * @see #getRes()
	 * @generated
	 */
	void setRes(AtlRes value);

	/**
	 * Returns the value of the '<em><b>Libarys</b></em>' reference list.
	 * The list contents are of type {@link de.urszeidler.eclipse.callchain.AtlLibary}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Libarys</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Libarys</em>' reference list.
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCall_Libarys()
	 * @model
	 * @generated
	 */
	EList<AtlLibary> getLibarys();

	/**
	 * Returns the value of the '<em><b>Allow Inter Model References</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Allow Inter Model References</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Allow Inter Model References</em>' attribute.
	 * @see #setAllowInterModelReferences(boolean)
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCall_AllowInterModelReferences()
	 * @model default="true"
	 * @generated
	 */
	boolean isAllowInterModelReferences();

	/**
	 * Sets the value of the '{@link de.urszeidler.eclipse.callchain.Call#isAllowInterModelReferences <em>Allow Inter Model References</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Allow Inter Model References</em>' attribute.
	 * @see #isAllowInterModelReferences()
	 * @generated
	 */
	void setAllowInterModelReferences(boolean value);

	/**
	 * Returns the value of the '<em><b>Continue After Errors</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Continue After Errors</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Continue After Errors</em>' attribute.
	 * @see #setContinueAfterErrors(boolean)
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCall_ContinueAfterErrors()
	 * @model default="true"
	 * @generated
	 */
	boolean isContinueAfterErrors();

	/**
	 * Sets the value of the '{@link de.urszeidler.eclipse.callchain.Call#isContinueAfterErrors <em>Continue After Errors</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Continue After Errors</em>' attribute.
	 * @see #isContinueAfterErrors()
	 * @generated
	 */
	void setContinueAfterErrors(boolean value);

	/**
	 * Returns the value of the '<em><b>Artifact</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Artifact</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Artifact</em>' reference.
	 * @see #setArtifact(Artifact)
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCall_Artifact()
	 * @model
	 * @generated
	 */
	Artifact getArtifact();

	/**
	 * Sets the value of the '{@link de.urszeidler.eclipse.callchain.Call#getArtifact <em>Artifact</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Artifact</em>' reference.
	 * @see #getArtifact()
	 * @generated
	 */
	void setArtifact(Artifact value);

	/**
	 * Returns the value of the '<em><b>Enviorment</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link de.urszeidler.eclipse.callchain.Calls#getCall <em>Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Enviorment</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Enviorment</em>' container reference.
	 * @see #setEnviorment(Calls)
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCall_Enviorment()
	 * @see de.urszeidler.eclipse.callchain.Calls#getCall
	 * @model opposite="call" transient="false"
	 *        annotation="http://urszeidler.de/m2m.transform excludedEReference='null'"
	 * @generated
	 */
	Calls getEnviorment();

	/**
	 * Sets the value of the '{@link de.urszeidler.eclipse.callchain.Call#getEnviorment <em>Enviorment</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Enviorment</em>' container reference.
	 * @see #getEnviorment()
	 * @generated
	 */
	void setEnviorment(Calls value);

	/**
	 * Returns the value of the '<em><b>Show Summary</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Show Summary</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Show Summary</em>' attribute.
	 * @see #setShowSummary(boolean)
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCall_ShowSummary()
	 * @model
	 * @generated
	 */
	boolean isShowSummary();

	/**
	 * Sets the value of the '{@link de.urszeidler.eclipse.callchain.Call#isShowSummary <em>Show Summary</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Show Summary</em>' attribute.
	 * @see #isShowSummary()
	 * @generated
	 */
	void setShowSummary(boolean value);

	/**
	 * Returns the value of the '<em><b>Print Execution Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Print Execution Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Print Execution Time</em>' attribute.
	 * @see #setPrintExecutionTime(boolean)
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCall_PrintExecutionTime()
	 * @model
	 * @generated
	 */
	boolean isPrintExecutionTime();

	/**
	 * Sets the value of the '{@link de.urszeidler.eclipse.callchain.Call#isPrintExecutionTime <em>Print Execution Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Print Execution Time</em>' attribute.
	 * @see #isPrintExecutionTime()
	 * @generated
	 */
	void setPrintExecutionTime(boolean value);

	/**
	 * Returns the value of the '<em><b>Disable Attribute Helper Cache</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Disable Attribute Helper Cache</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Disable Attribute Helper Cache</em>' attribute.
	 * @see #setDisableAttributeHelperCache(boolean)
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCall_DisableAttributeHelperCache()
	 * @model
	 * @generated
	 */
	boolean isDisableAttributeHelperCache();

	/**
	 * Sets the value of the '{@link de.urszeidler.eclipse.callchain.Call#isDisableAttributeHelperCache <em>Disable Attribute Helper Cache</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Disable Attribute Helper Cache</em>' attribute.
	 * @see #isDisableAttributeHelperCache()
	 * @generated
	 */
	void setDisableAttributeHelperCache(boolean value);

	/**
	 * Returns the value of the '<em><b>Profile</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Profile</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Profile</em>' attribute.
	 * @see #setProfile(boolean)
	 * @see de.urszeidler.eclipse.callchain.CallchainPackage#getCall_Profile()
	 * @model
	 * @generated
	 */
	boolean isProfile();

	/**
	 * Sets the value of the '{@link de.urszeidler.eclipse.callchain.Call#isProfile <em>Profile</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Profile</em>' attribute.
	 * @see #isProfile()
	 * @generated
	 */
	void setProfile(boolean value);

} // Call
