/**
 * 
 */
package de.urszeidler.eclipse.callchain.diagram.edit.part;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.common.ui.services.icon.IconService;
import org.eclipse.gmf.runtime.diagram.core.preferences.PreferencesHint;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.DiagramPopupBarEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.requests.CreateViewRequestFactory;
import org.eclipse.gmf.runtime.diagram.ui.tools.PopupBarTool;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.modelingassistant.ModelingAssistantService;
import org.eclipse.swt.graphics.Image;

import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;
import de.urszeidler.eclipse.callchain.generatorservice.GeneratorDescriptor;

public class CustomDiagramPopupBarEditPolicy extends DiagramPopupBarEditPolicy {
	private static final class PopupBarToolExtension extends PopupBarTool {
		private GeneratorDescriptor descriptor;

		PopupBarToolExtension(EditPart epHost, IElementType elementType, GeneratorDescriptor descriptor) {
			super(epHost, createTargetRequest1(descriptor,elementType,epHost));
			//super(epHost, elementType);
			this.descriptor = descriptor;
			
			

		}
		
		/**
		 * @param descriptor2 
		 * @param elementType 
		 * @param epHost 
		 * @see org.eclipse.gef.tools.TargetingTool#createTargetRequest()
		 */
		protected static CreateRequest createTargetRequest1(GeneratorDescriptor descriptor2, IElementType elementType, EditPart epHost) {

//			/* if we have a request, use it */
//			if (getCreateRequest() != null) {
//				 CreateRequest request = getCreateRequest();
//				 request.getExtendedData().put("generator_descriptor", descriptor);
//				 return request;
//			}

			CreateRequest request =  CreateViewRequestFactory.getCreateShapeRequest(elementType,
				getPreferencesHint1(epHost));
			request.getExtendedData().put("generator_descriptor", descriptor2);
			return request;
		}

//		/**
//		 * @see org.eclipse.gef.tools.TargetingTool#createTargetRequest()
//		 */
//		protected Request createTargetRequest() {
//
//			/* if we have a request, use it */
//			if (getCreateRequest() != null) {
//				 CreateRequest request = getCreateRequest();
//				 //request.getExtendedData().put("generator_descriptor", descriptor);
//				 return request;
//			}
//
//			CreateRequest request =  CreateViewRequestFactory.getCreateShapeRequest(getElementType(),
//				getPreferencesHint());
//			request.getExtendedData().put("generator_descriptor", descriptor);
//			return request;
//		}
//
		protected static PreferencesHint getPreferencesHint1(EditPart myHostEditPart) {
			PreferencesHint preferencesHint = null;
			if (myHostEditPart != null) {
				preferencesHint = ((IGraphicalEditPart) myHostEditPart)
					.getDiagramPreferencesHint();
			}
			return preferencesHint;
		}

	}

	protected void populatePopupBars() {
		fillPopupBarDescriptors();
		List types = ModelingAssistantService.getInstance().getTypesForPopupBar(getHost());
		for (Iterator iter = types.iterator(); iter.hasNext();) {
			Object type = iter.next();
			if (type instanceof IElementType) {
				addPopupBarDescriptor((IElementType) type, IconService.getInstance().getIcon((IElementType) type));
			}
		}
		Collection<GeneratorDescriptor> availableGenerators = de.urszeidler.eclipse.callchain.generatorservice.Generatorservice
				.getDefault().generatorDescriptors();
		for (GeneratorDescriptor generatorDescriptor : availableGenerators) {
			addPopupBarDescriptor(CallchainElementTypes.Generic_Generator_2027, generatorDescriptor.getSmallImage(),
					new PopupBarToolExtension(getHost(), CallchainElementTypes.Generic_Generator_2027,generatorDescriptor));

		}

	}

	/**
	 * default method for plugins which passes along the PopupBarTool as the
	 * tool to be used.
	 * 
	 * @param elementType
	 * @param theImage
	 */
	protected void addPopupBarDescriptor(IElementType elementType, Image theImage) {

		this.addPopupBarDescriptor(elementType, theImage, new PopupBarTool(getHost(), elementType));

	}
}