package de.urszeidler.eclipse.callchain.diagram.edit.policies;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.commands.core.commands.DuplicateEObjectsCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DuplicateElementsRequest;

import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.AM3_GeneratorCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.ArtifactCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.AtlLibaryCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.AtlResCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CommentCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.EMF_GeneratorCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.GMF_GeneratorCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.Generic_GeneratorCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.MMCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.ModelCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.TopcasedGeneratorCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.Useit_GeneratorCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;

/**
 * @generated
 */
public class CallsItemSemanticEditPolicy extends
		CallchainBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (CallchainElementTypes.Model_2015 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(CallchainPackage.eINSTANCE
						.getCalls_Artifacts());
			}
			return getGEFWrapper(new ModelCreateCommand(req));
		}
		if (CallchainElementTypes.AtlRes_2016 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(CallchainPackage.eINSTANCE
						.getCalls_Artifacts());
			}
			return getGEFWrapper(new AtlResCreateCommand(req));
		}
		if (CallchainElementTypes.Call_2017 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(CallchainPackage.eINSTANCE
						.getCalls_Call());
			}
			return getGEFWrapper(new CallCreateCommand(req));
		}
		if (CallchainElementTypes.MM_2018 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(CallchainPackage.eINSTANCE
						.getCalls_Artifacts());
			}
			return getGEFWrapper(new MMCreateCommand(req));
		}
		if (CallchainElementTypes.AtlLibary_2019 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(CallchainPackage.eINSTANCE
						.getCalls_Artifacts());
			}
			return getGEFWrapper(new AtlLibaryCreateCommand(req));
		}
		if (CallchainElementTypes.Artifact_2020 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(CallchainPackage.eINSTANCE
						.getCalls_Artifacts());
			}
			return getGEFWrapper(new ArtifactCreateCommand(req));
		}
		if (CallchainElementTypes.EMF_Generator_2021 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(CallchainPackage.eINSTANCE
						.getCalls_Generators());
			}
			return getGEFWrapper(new EMF_GeneratorCreateCommand(req));
		}
		if (CallchainElementTypes.Useit_Generator_2022 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(CallchainPackage.eINSTANCE
						.getCalls_Generators());
			}
			return getGEFWrapper(new Useit_GeneratorCreateCommand(req));
		}
		if (CallchainElementTypes.TopcasedGenerator_2023 == req
				.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(CallchainPackage.eINSTANCE
						.getCalls_Generators());
			}
			return getGEFWrapper(new TopcasedGeneratorCreateCommand(req));
		}
		if (CallchainElementTypes.Comment_2024 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(CallchainPackage.eINSTANCE
						.getDocumentable_Comments());
			}
			return getGEFWrapper(new CommentCreateCommand(req));
		}
		if (CallchainElementTypes.AM3_Generator_2025 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(CallchainPackage.eINSTANCE
						.getCalls_Generators());
			}
			return getGEFWrapper(new AM3_GeneratorCreateCommand(req));
		}
		if (CallchainElementTypes.GMF_Generator_2026 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(CallchainPackage.eINSTANCE
						.getCalls_Generators());
			}
			return getGEFWrapper(new GMF_GeneratorCreateCommand(req));
		}
		if (CallchainElementTypes.Generic_Generator_2027 == req
				.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(CallchainPackage.eINSTANCE
						.getCalls_Generators());
			}
			return getGEFWrapper(new Generic_GeneratorCreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDuplicateCommand(DuplicateElementsRequest req) {
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) getHost())
				.getEditingDomain();
		return getGEFWrapper(new DuplicateAnythingCommand(editingDomain, req));
	}

	/**
	 * @generated
	 */
	private static class DuplicateAnythingCommand extends
			DuplicateEObjectsCommand {

		/**
		 * @generated
		 */
		public DuplicateAnythingCommand(
				TransactionalEditingDomain editingDomain,
				DuplicateElementsRequest req) {
			super(editingDomain, req.getLabel(), req
					.getElementsToBeDuplicated(), req
					.getAllDuplicatedElementsMap());
		}

	}

}
