package de.urszeidler.eclipse.callchain.diagram.edit.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;
import org.eclipse.gmf.runtime.notation.View;

import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallArtifactCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallArtifactReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallInCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallInReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallOutCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallOutReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CommentDocumentedElementCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CommentDocumentedElementReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.GeneratorProduceCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.GeneratorProduceReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.GeneratorUsesCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.GeneratorUsesReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.MMAliasCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.MMAliasReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.ModelAliasCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.ModelAliasReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.ModelMmCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.ModelMmReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallInEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallOutEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentDocumentedElementEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GeneratorProduceEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GeneratorUsesEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMAliasEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelAliasEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelMmEditPart;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;

/**
 * @generated
 */
public class ModelItemSemanticEditPolicy extends
		CallchainBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		CompoundCommand cc = getDestroyEdgesCommand();
		addDestroyShortcutsCommand(cc);
		View view = (View) getHost().getModel();
		if (view.getEAnnotation("Shortcut") != null) { //$NON-NLS-1$
			req.setElementToDestroy(view);
		}
		cc.add(getGEFWrapper(new DestroyElementCommand(req)));
		return cc.unwrap();
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req)
				: getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super
				.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (CallchainElementTypes.ModelAlias_4016 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.MMAlias_4017 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.ModelMm_4018 == req.getElementType()) {
			return getGEFWrapper(new ModelMmCreateCommand(req, req.getSource(),
					req.getTarget()));
		}
		if (CallchainElementTypes.CallIn_4020 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallOut_4021 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallArtifact_4024 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CommentDocumentedElement_4025 == req
				.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.GeneratorUses_4026 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.GeneratorProduce_4027 == req.getElementType()) {
			return null;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (CallchainElementTypes.ModelAlias_4016 == req.getElementType()) {
			return getGEFWrapper(new ModelAliasCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.MMAlias_4017 == req.getElementType()) {
			return getGEFWrapper(new MMAliasCreateCommand(req, req.getSource(),
					req.getTarget()));
		}
		if (CallchainElementTypes.ModelMm_4018 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallIn_4020 == req.getElementType()) {
			return getGEFWrapper(new CallInCreateCommand(req, req.getSource(),
					req.getTarget()));
		}
		if (CallchainElementTypes.CallOut_4021 == req.getElementType()) {
			return getGEFWrapper(new CallOutCreateCommand(req, req.getSource(),
					req.getTarget()));
		}
		if (CallchainElementTypes.CallArtifact_4024 == req.getElementType()) {
			return getGEFWrapper(new CallArtifactCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CommentDocumentedElement_4025 == req
				.getElementType()) {
			return getGEFWrapper(new CommentDocumentedElementCreateCommand(req,
					req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.GeneratorUses_4026 == req.getElementType()) {
			return getGEFWrapper(new GeneratorUsesCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.GeneratorProduce_4027 == req.getElementType()) {
			return getGEFWrapper(new GeneratorProduceCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * Returns command to reorient EClass based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientRelationshipCommand(
			ReorientRelationshipRequest req) {
		switch (getVisualID(req)) {
		case ModelAliasEditPart.VISUAL_ID:
			return getGEFWrapper(new ModelAliasReorientCommand(req));
		case MMAliasEditPart.VISUAL_ID:
			return getGEFWrapper(new MMAliasReorientCommand(req));
		}
		return super.getReorientRelationshipCommand(req);
	}

	/**
	 * Returns command to reorient EReference based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientReferenceRelationshipCommand(
			ReorientReferenceRelationshipRequest req) {
		switch (getVisualID(req)) {
		case ModelMmEditPart.VISUAL_ID:
			return getGEFWrapper(new ModelMmReorientCommand(req));
		case CallInEditPart.VISUAL_ID:
			return getGEFWrapper(new CallInReorientCommand(req));
		case CallOutEditPart.VISUAL_ID:
			return getGEFWrapper(new CallOutReorientCommand(req));
		case CallArtifactEditPart.VISUAL_ID:
			return getGEFWrapper(new CallArtifactReorientCommand(req));
		case CommentDocumentedElementEditPart.VISUAL_ID:
			return getGEFWrapper(new CommentDocumentedElementReorientCommand(
					req));
		case GeneratorUsesEditPart.VISUAL_ID:
			return getGEFWrapper(new GeneratorUsesReorientCommand(req));
		case GeneratorProduceEditPart.VISUAL_ID:
			return getGEFWrapper(new GeneratorProduceReorientCommand(req));
		}
		return super.getReorientReferenceRelationshipCommand(req);
	}

}
