package de.urszeidler.eclipse.callchain.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;

import de.urszeidler.eclipse.callchain.AM3_Generator;
import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.AtlLibary;
import de.urszeidler.eclipse.callchain.AtlRes;
import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.Callable;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.Comment;
import de.urszeidler.eclipse.callchain.Documentable;
import de.urszeidler.eclipse.callchain.EMF_Generator;
import de.urszeidler.eclipse.callchain.GMF_Generator;
import de.urszeidler.eclipse.callchain.Generator;
import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.MMAlias;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.ModelAlias;
import de.urszeidler.eclipse.callchain.TopcasedGenerator;
import de.urszeidler.eclipse.callchain.Useit_Generator;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AM3_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResSuperimposeEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallInEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallLibarysEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallOutEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallResEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallableNextEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallsEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentDocumentedElementEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.EMF_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GMF_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GeneratorProduceEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GeneratorUsesEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Generic_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMAliasEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelAliasEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelMmEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TopcasedGeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Useit_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;

/**
 * @generated
 */
public class CallchainDiagramUpdater {

	/**
	 * @generated
	 */
	public static List getSemanticChildren(View view) {
		switch (CallchainVisualIDRegistry.getVisualID(view)) {
		case CallsEditPart.VISUAL_ID:
			return getCalls_1000SemanticChildren(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getCalls_1000SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		Calls modelElement = (Calls) view.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getArtifacts().iterator(); it.hasNext();) {
			Artifact childElement = (Artifact) it.next();
			int visualID = CallchainVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ModelEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AtlResEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MMEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AtlLibaryEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ArtifactEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator it = modelElement.getCall().iterator(); it.hasNext();) {
			Call childElement = (Call) it.next();
			int visualID = CallchainVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == CallEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator it = modelElement.getGenerators().iterator(); it
				.hasNext();) {
			Generator childElement = (Generator) it.next();
			int visualID = CallchainVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == EMF_GeneratorEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == Useit_GeneratorEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TopcasedGeneratorEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AM3_GeneratorEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == GMF_GeneratorEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == Generic_GeneratorEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator it = modelElement.getComments().iterator(); it.hasNext();) {
			Comment childElement = (Comment) it.next();
			int visualID = CallchainVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == CommentEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getContainedLinks(View view) {
		switch (CallchainVisualIDRegistry.getVisualID(view)) {
		case CallsEditPart.VISUAL_ID:
			return getCalls_1000ContainedLinks(view);
		case ModelEditPart.VISUAL_ID:
			return getModel_2015ContainedLinks(view);
		case AtlResEditPart.VISUAL_ID:
			return getAtlRes_2016ContainedLinks(view);
		case CallEditPart.VISUAL_ID:
			return getCall_2017ContainedLinks(view);
		case MMEditPart.VISUAL_ID:
			return getMM_2018ContainedLinks(view);
		case AtlLibaryEditPart.VISUAL_ID:
			return getAtlLibary_2019ContainedLinks(view);
		case ArtifactEditPart.VISUAL_ID:
			return getArtifact_2020ContainedLinks(view);
		case EMF_GeneratorEditPart.VISUAL_ID:
			return getEMF_Generator_2021ContainedLinks(view);
		case Useit_GeneratorEditPart.VISUAL_ID:
			return getUseit_Generator_2022ContainedLinks(view);
		case TopcasedGeneratorEditPart.VISUAL_ID:
			return getTopcasedGenerator_2023ContainedLinks(view);
		case CommentEditPart.VISUAL_ID:
			return getComment_2024ContainedLinks(view);
		case AM3_GeneratorEditPart.VISUAL_ID:
			return getAM3_Generator_2025ContainedLinks(view);
		case GMF_GeneratorEditPart.VISUAL_ID:
			return getGMF_Generator_2026ContainedLinks(view);
		case Generic_GeneratorEditPart.VISUAL_ID:
			return getGeneric_Generator_2027ContainedLinks(view);
		case ModelAliasEditPart.VISUAL_ID:
			return getModelAlias_4016ContainedLinks(view);
		case MMAliasEditPart.VISUAL_ID:
			return getMMAlias_4017ContainedLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getIncomingLinks(View view) {
		switch (CallchainVisualIDRegistry.getVisualID(view)) {
		case ModelEditPart.VISUAL_ID:
			return getModel_2015IncomingLinks(view);
		case AtlResEditPart.VISUAL_ID:
			return getAtlRes_2016IncomingLinks(view);
		case CallEditPart.VISUAL_ID:
			return getCall_2017IncomingLinks(view);
		case MMEditPart.VISUAL_ID:
			return getMM_2018IncomingLinks(view);
		case AtlLibaryEditPart.VISUAL_ID:
			return getAtlLibary_2019IncomingLinks(view);
		case ArtifactEditPart.VISUAL_ID:
			return getArtifact_2020IncomingLinks(view);
		case EMF_GeneratorEditPart.VISUAL_ID:
			return getEMF_Generator_2021IncomingLinks(view);
		case Useit_GeneratorEditPart.VISUAL_ID:
			return getUseit_Generator_2022IncomingLinks(view);
		case TopcasedGeneratorEditPart.VISUAL_ID:
			return getTopcasedGenerator_2023IncomingLinks(view);
		case CommentEditPart.VISUAL_ID:
			return getComment_2024IncomingLinks(view);
		case AM3_GeneratorEditPart.VISUAL_ID:
			return getAM3_Generator_2025IncomingLinks(view);
		case GMF_GeneratorEditPart.VISUAL_ID:
			return getGMF_Generator_2026IncomingLinks(view);
		case Generic_GeneratorEditPart.VISUAL_ID:
			return getGeneric_Generator_2027IncomingLinks(view);
		case ModelAliasEditPart.VISUAL_ID:
			return getModelAlias_4016IncomingLinks(view);
		case MMAliasEditPart.VISUAL_ID:
			return getMMAlias_4017IncomingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOutgoingLinks(View view) {
		switch (CallchainVisualIDRegistry.getVisualID(view)) {
		case ModelEditPart.VISUAL_ID:
			return getModel_2015OutgoingLinks(view);
		case AtlResEditPart.VISUAL_ID:
			return getAtlRes_2016OutgoingLinks(view);
		case CallEditPart.VISUAL_ID:
			return getCall_2017OutgoingLinks(view);
		case MMEditPart.VISUAL_ID:
			return getMM_2018OutgoingLinks(view);
		case AtlLibaryEditPart.VISUAL_ID:
			return getAtlLibary_2019OutgoingLinks(view);
		case ArtifactEditPart.VISUAL_ID:
			return getArtifact_2020OutgoingLinks(view);
		case EMF_GeneratorEditPart.VISUAL_ID:
			return getEMF_Generator_2021OutgoingLinks(view);
		case Useit_GeneratorEditPart.VISUAL_ID:
			return getUseit_Generator_2022OutgoingLinks(view);
		case TopcasedGeneratorEditPart.VISUAL_ID:
			return getTopcasedGenerator_2023OutgoingLinks(view);
		case CommentEditPart.VISUAL_ID:
			return getComment_2024OutgoingLinks(view);
		case AM3_GeneratorEditPart.VISUAL_ID:
			return getAM3_Generator_2025OutgoingLinks(view);
		case GMF_GeneratorEditPart.VISUAL_ID:
			return getGMF_Generator_2026OutgoingLinks(view);
		case Generic_GeneratorEditPart.VISUAL_ID:
			return getGeneric_Generator_2027OutgoingLinks(view);
		case ModelAliasEditPart.VISUAL_ID:
			return getModelAlias_4016OutgoingLinks(view);
		case MMAliasEditPart.VISUAL_ID:
			return getMMAlias_4017OutgoingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getCalls_1000ContainedLinks(View view) {
		Calls modelElement = (Calls) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getContainedTypeModelFacetLinks_MMAlias_4017(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getModel_2015ContainedLinks(View view) {
		Model modelElement = (Model) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Model_Mm_4018(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAtlRes_2016ContainedLinks(View view) {
		AtlRes modelElement = (AtlRes) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_AtlRes_Superimpose_4019(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getCall_2017ContainedLinks(View view) {
		Call modelElement = (Call) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getContainedTypeModelFacetLinks_ModelAlias_4016(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Call_In_4020(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Call_Out_4021(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Call_Res_4022(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Call_Libarys_4023(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Call_Artifact_4024(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getMM_2018ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getAtlLibary_2019ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getArtifact_2020ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getEMF_Generator_2021ContainedLinks(View view) {
		EMF_Generator modelElement = (EMF_Generator) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Uses_4026(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Produce_4027(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getUseit_Generator_2022ContainedLinks(View view) {
		Useit_Generator modelElement = (Useit_Generator) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Uses_4026(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Produce_4027(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getTopcasedGenerator_2023ContainedLinks(View view) {
		TopcasedGenerator modelElement = (TopcasedGenerator) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Uses_4026(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Produce_4027(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getComment_2024ContainedLinks(View view) {
		Comment modelElement = (Comment) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Comment_DocumentedElement_4025(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAM3_Generator_2025ContainedLinks(View view) {
		AM3_Generator modelElement = (AM3_Generator) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Uses_4026(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Produce_4027(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getGMF_Generator_2026ContainedLinks(View view) {
		GMF_Generator modelElement = (GMF_Generator) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Uses_4026(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Produce_4027(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getGeneric_Generator_2027ContainedLinks(View view) {
		Generic_Generator modelElement = (Generic_Generator) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Uses_4026(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Produce_4027(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getModelAlias_4016ContainedLinks(View view) {
		ModelAlias modelElement = (ModelAlias) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Model_Mm_4018(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getMMAlias_4017ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getModel_2015IncomingLinks(View view) {
		Model modelElement = (Model) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingTypeModelFacetLinks_ModelAlias_4016(
				modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_MMAlias_4017(modelElement,
				crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_In_4020(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Out_4021(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Artifact_4024(
				modelElement, crossReferences));
		result
				.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
						modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Uses_4026(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Produce_4027(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAtlRes_2016IncomingLinks(View view) {
		AtlRes modelElement = (AtlRes) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_AtlRes_Superimpose_4019(
						modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Res_4022(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Artifact_4024(
				modelElement, crossReferences));
		result
				.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
						modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Uses_4026(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Produce_4027(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getCall_2017IncomingLinks(View view) {
		Call modelElement = (Call) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
						modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Callable_Next_4028(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getMM_2018IncomingLinks(View view) {
		de.urszeidler.eclipse.callchain.MM modelElement = (de.urszeidler.eclipse.callchain.MM) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingFeatureModelFacetLinks_Model_Mm_4018(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Artifact_4024(
				modelElement, crossReferences));
		result
				.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
						modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Uses_4026(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Produce_4027(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAtlLibary_2019IncomingLinks(View view) {
		AtlLibary modelElement = (AtlLibary) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Libarys_4023(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Artifact_4024(
				modelElement, crossReferences));
		result
				.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
						modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Uses_4026(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Produce_4027(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getArtifact_2020IncomingLinks(View view) {
		Artifact modelElement = (Artifact) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Artifact_4024(
				modelElement, crossReferences));
		result
				.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
						modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Uses_4026(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Produce_4027(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getEMF_Generator_2021IncomingLinks(View view) {
		EMF_Generator modelElement = (EMF_Generator) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
						modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Callable_Next_4028(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getUseit_Generator_2022IncomingLinks(View view) {
		Useit_Generator modelElement = (Useit_Generator) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
						modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Callable_Next_4028(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getTopcasedGenerator_2023IncomingLinks(View view) {
		TopcasedGenerator modelElement = (TopcasedGenerator) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
						modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Callable_Next_4028(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getComment_2024IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getAM3_Generator_2025IncomingLinks(View view) {
		AM3_Generator modelElement = (AM3_Generator) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
						modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Callable_Next_4028(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getGMF_Generator_2026IncomingLinks(View view) {
		GMF_Generator modelElement = (GMF_Generator) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
						modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Callable_Next_4028(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getGeneric_Generator_2027IncomingLinks(View view) {
		Generic_Generator modelElement = (Generic_Generator) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
						modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Callable_Next_4028(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getModelAlias_4016IncomingLinks(View view) {
		ModelAlias modelElement = (ModelAlias) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingTypeModelFacetLinks_ModelAlias_4016(
				modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_MMAlias_4017(modelElement,
				crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_In_4020(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Out_4021(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Artifact_4024(
				modelElement, crossReferences));
		result
				.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
						modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Uses_4026(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Produce_4027(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getMMAlias_4017IncomingLinks(View view) {
		MMAlias modelElement = (MMAlias) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingFeatureModelFacetLinks_Model_Mm_4018(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Artifact_4024(
				modelElement, crossReferences));
		result
				.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
						modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Uses_4026(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Produce_4027(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getModel_2015OutgoingLinks(View view) {
		Model modelElement = (Model) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Model_Mm_4018(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAtlRes_2016OutgoingLinks(View view) {
		AtlRes modelElement = (AtlRes) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_AtlRes_Superimpose_4019(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getCall_2017OutgoingLinks(View view) {
		Call modelElement = (Call) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getContainedTypeModelFacetLinks_ModelAlias_4016(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Call_In_4020(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Call_Out_4021(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Call_Res_4022(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Call_Libarys_4023(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Call_Artifact_4024(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getMM_2018OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getAtlLibary_2019OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getArtifact_2020OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getEMF_Generator_2021OutgoingLinks(View view) {
		EMF_Generator modelElement = (EMF_Generator) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Uses_4026(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Produce_4027(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getUseit_Generator_2022OutgoingLinks(View view) {
		Useit_Generator modelElement = (Useit_Generator) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Uses_4026(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Produce_4027(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getTopcasedGenerator_2023OutgoingLinks(View view) {
		TopcasedGenerator modelElement = (TopcasedGenerator) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Uses_4026(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Produce_4027(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getComment_2024OutgoingLinks(View view) {
		Comment modelElement = (Comment) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Comment_DocumentedElement_4025(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAM3_Generator_2025OutgoingLinks(View view) {
		AM3_Generator modelElement = (AM3_Generator) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Uses_4026(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Produce_4027(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getGMF_Generator_2026OutgoingLinks(View view) {
		GMF_Generator modelElement = (GMF_Generator) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Uses_4026(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Produce_4027(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getGeneric_Generator_2027OutgoingLinks(View view) {
		Generic_Generator modelElement = (Generic_Generator) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Uses_4026(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Generator_Produce_4027(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getModelAlias_4016OutgoingLinks(View view) {
		ModelAlias modelElement = (ModelAlias) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Model_Mm_4018(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getMMAlias_4017OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	private static Collection getContainedTypeModelFacetLinks_ModelAlias_4016(
			Call container) {
		Collection result = new LinkedList();
		for (Iterator links = container.getIn().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof ModelAlias) {
				continue;
			}
			ModelAlias link = (ModelAlias) linkObject;
			if (ModelAliasEditPart.VISUAL_ID != CallchainVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Model dst = link.getDecoratedmodel();
			result.add(new CallchainLinkDescriptor(container, dst, link,
					CallchainElementTypes.ModelAlias_4016,
					ModelAliasEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getContainedTypeModelFacetLinks_MMAlias_4017(
			Calls container) {
		Collection result = new LinkedList();
		for (Iterator links = container.getArtifacts().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof MMAlias) {
				continue;
			}
			MMAlias link = (MMAlias) linkObject;
			if (MMAliasEditPart.VISUAL_ID != CallchainVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Model dst = link.getDecoratedmodel();
			result.add(new CallchainLinkDescriptor(container, dst, link,
					CallchainElementTypes.MMAlias_4017,
					MMAliasEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingTypeModelFacetLinks_ModelAlias_4016(
			Model target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() != CallchainPackage.eINSTANCE
					.getModelAlias_Decoratedmodel()
					|| false == setting.getEObject() instanceof ModelAlias) {
				continue;
			}
			ModelAlias link = (ModelAlias) setting.getEObject();
			if (ModelAliasEditPart.VISUAL_ID != CallchainVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			if (false == link.eContainer() instanceof Call) {
				continue;
			}
			Call container = (Call) link.eContainer();
			result.add(new CallchainLinkDescriptor(container, target, link,
					CallchainElementTypes.ModelAlias_4016,
					ModelAliasEditPart.VISUAL_ID));

		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingTypeModelFacetLinks_MMAlias_4017(
			Model target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() != CallchainPackage.eINSTANCE
					.getMMAlias_Decoratedmodel()
					|| false == setting.getEObject() instanceof MMAlias) {
				continue;
			}
			MMAlias link = (MMAlias) setting.getEObject();
			if (MMAliasEditPart.VISUAL_ID != CallchainVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			if (false == link.eContainer() instanceof Calls) {
				continue;
			}
			Calls container = (Calls) link.eContainer();
			result.add(new CallchainLinkDescriptor(container, target, link,
					CallchainElementTypes.MMAlias_4017,
					MMAliasEditPart.VISUAL_ID));

		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_Model_Mm_4018(
			de.urszeidler.eclipse.callchain.MM target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE
					.getModel_Mm()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(),
						target, CallchainElementTypes.ModelMm_4018,
						ModelMmEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_AtlRes_Superimpose_4019(
			AtlRes target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE
					.getAtlRes_Superimpose()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(),
						target, CallchainElementTypes.AtlResSuperimpose_4019,
						AtlResSuperimposeEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_Call_In_4020(
			Model target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE
					.getCall_In()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(),
						target, CallchainElementTypes.CallIn_4020,
						CallInEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_Call_Out_4021(
			Model target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE
					.getCall_Out()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(),
						target, CallchainElementTypes.CallOut_4021,
						CallOutEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_Call_Res_4022(
			AtlRes target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE
					.getCall_Res()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(),
						target, CallchainElementTypes.CallRes_4022,
						CallResEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_Call_Libarys_4023(
			AtlLibary target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE
					.getCall_Libarys()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(),
						target, CallchainElementTypes.CallLibarys_4023,
						CallLibarysEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_Call_Artifact_4024(
			Artifact target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE
					.getCall_Artifact()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(),
						target, CallchainElementTypes.CallArtifact_4024,
						CallArtifactEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
			Documentable target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE
					.getComment_DocumentedElement()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(),
						target,
						CallchainElementTypes.CommentDocumentedElement_4025,
						CommentDocumentedElementEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_Generator_Uses_4026(
			Artifact target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE
					.getGenerator_Uses()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(),
						target, CallchainElementTypes.GeneratorUses_4026,
						GeneratorUsesEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_Generator_Produce_4027(
			Artifact target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE
					.getGenerator_Produce()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(),
						target, CallchainElementTypes.GeneratorProduce_4027,
						GeneratorProduceEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_Callable_Next_4028(
			Callable target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE
					.getCallable_Next()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(),
						target, CallchainElementTypes.CallableNext_4028,
						CallableNextEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated not
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_Model_Mm_4018(
			Model source) {
		Collection result = new LinkedList();
		de.urszeidler.eclipse.callchain.MM destination = source.getMm();
		if (destination == null) {
			return result;
		}
		if (!(source instanceof ModelAlias))
		result.add(new CallchainLinkDescriptor(source, destination,
				CallchainElementTypes.ModelMm_4018, ModelMmEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_AtlRes_Superimpose_4019(
			AtlRes source) {
		Collection result = new LinkedList();
		for (Iterator destinations = source.getSuperimpose().iterator(); destinations
				.hasNext();) {
			AtlRes destination = (AtlRes) destinations.next();
			result.add(new CallchainLinkDescriptor(source, destination,
					CallchainElementTypes.AtlResSuperimpose_4019,
					AtlResSuperimposeEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated not
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_Call_In_4020(
			Call source) {
		Collection result = new LinkedList();
		for (Iterator destinations = source.getIn().iterator(); destinations
				.hasNext();) {
			Model destination = (Model) destinations.next();
			if(!ModelAlias.class.isInstance(destination))
				result
						.add(new CallchainLinkDescriptor(source, destination,
								CallchainElementTypes.CallIn_4020,
								CallInEditPart.VISUAL_ID));
				
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_Call_Out_4021(
			Call source) {
		Collection result = new LinkedList();
		for (Iterator destinations = source.getOut().iterator(); destinations
				.hasNext();) {
			Model destination = (Model) destinations.next();
			result.add(new CallchainLinkDescriptor(source, destination,
					CallchainElementTypes.CallOut_4021,
					CallOutEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_Call_Res_4022(
			Call source) {
		Collection result = new LinkedList();
		AtlRes destination = source.getRes();
		if (destination == null) {
			return result;
		}
		result.add(new CallchainLinkDescriptor(source, destination,
				CallchainElementTypes.CallRes_4022, CallResEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_Call_Libarys_4023(
			Call source) {
		Collection result = new LinkedList();
		for (Iterator destinations = source.getLibarys().iterator(); destinations
				.hasNext();) {
			AtlLibary destination = (AtlLibary) destinations.next();
			result.add(new CallchainLinkDescriptor(source, destination,
					CallchainElementTypes.CallLibarys_4023,
					CallLibarysEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_Call_Artifact_4024(
			Call source) {
		Collection result = new LinkedList();
		Artifact destination = source.getArtifact();
		if (destination == null) {
			return result;
		}
		result.add(new CallchainLinkDescriptor(source, destination,
				CallchainElementTypes.CallArtifact_4024,
				CallArtifactEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
			Comment source) {
		Collection result = new LinkedList();
		for (Iterator destinations = source.getDocumentedElement().iterator(); destinations
				.hasNext();) {
			Documentable destination = (Documentable) destinations.next();
			result.add(new CallchainLinkDescriptor(source, destination,
					CallchainElementTypes.CommentDocumentedElement_4025,
					CommentDocumentedElementEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_Generator_Uses_4026(
			Generator source) {
		Collection result = new LinkedList();
		for (Iterator destinations = source.getUses().iterator(); destinations
				.hasNext();) {
			Artifact destination = (Artifact) destinations.next();
			result.add(new CallchainLinkDescriptor(source, destination,
					CallchainElementTypes.GeneratorUses_4026,
					GeneratorUsesEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_Generator_Produce_4027(
			Generator source) {
		Collection result = new LinkedList();
		for (Iterator destinations = source.getProduce().iterator(); destinations
				.hasNext();) {
			Artifact destination = (Artifact) destinations.next();
			result.add(new CallchainLinkDescriptor(source, destination,
					CallchainElementTypes.GeneratorProduce_4027,
					GeneratorProduceEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_Callable_Next_4028(
			Callable source) {
		Collection result = new LinkedList();
		Callable destination = source.getNext();
		if (destination == null) {
			return result;
		}
		result.add(new CallchainLinkDescriptor(source, destination,
				CallchainElementTypes.CallableNext_4028,
				CallableNextEditPart.VISUAL_ID));
		return result;
	}

}
