package de.urszeidler.eclipse.callchain.diagram.part;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.edit.command.SetCommand;
import org.eclipse.gef.Tool;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.PaletteStack;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gmf.runtime.common.core.command.ICompositeCommand;
import org.eclipse.gmf.runtime.diagram.ui.commands.ICommandProxy;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;

import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.Generic_GeneratorCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;
import de.urszeidler.eclipse.callchain.generatorservice.Category;
import de.urszeidler.eclipse.callchain.generatorservice.GeneratorDescriptor;

/**
 * @generated
 */
public class CallchainPaletteFactory {
	// public class CustomHintedType extends MetamodelType implements
	// IHintedType{
	//
	// public CustomHintedType(IMetamodelTypeDescriptor descriptor) {
	// super(descriptor);
	//			
	// }
	//
	// @Override
	// public String getSemanticHint() {
	// // TODO Auto-generated method stub
	// return null;
	// }
	//		
	// }
	/**
	 * @generated
	 */
	public void fillPalette(PaletteRoot paletteRoot) {
		paletteRoot.add(createComment1Group());
		paletteRoot.add(createArtifacts2Group());
		paletteRoot.add(createCall3Group());
		paletteRoot.add(createGenerators4Group());
	}

	/**
	 * Creates "comment" palette tool group
	 * 
	 * @generated
	 */
	private PaletteContainer createComment1Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(Messages.Comment1Group_title);
		paletteContainer.add(createComment1CreationTool());
		paletteContainer.add(createCommentdocumentedElement2CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "artifacts" palette tool group
	 * 
	 * @generated
	 */
	private PaletteContainer createArtifacts2Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(Messages.Artifacts2Group_title);
		paletteContainer.add(createArtifact1CreationTool());
		paletteContainer.add(createModel2CreationTool());
		paletteContainer.add(createAtlRes3CreationTool());
		paletteContainer.add(createAtlLibary4CreationTool());
		paletteContainer.add(createModelAlias5CreationTool());
		paletteContainer.add(createMM6CreationTool());
		paletteContainer.add(createModelmm7CreationTool());
		paletteContainer.add(createMMAlias8CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "call" palette tool group
	 * 
	 * @generated
	 */
	private PaletteContainer createCall3Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(Messages.Call3Group_title);
		paletteContainer.add(createCall1CreationTool());
		paletteContainer.add(createCallin2CreationTool());
		paletteContainer.add(createCallout3CreationTool());
		paletteContainer.add(createCallartifact4CreationTool());
		paletteContainer.add(createCalllibarys5CreationTool());
		paletteContainer.add(createCallres6CreationTool());
		paletteContainer.add(createAtlRessuperimpose7CreationTool());
		paletteContainer.add(createCallablenext8CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "generators" palette tool group
	 * 
	 * @generated not
	 */
	private PaletteContainer createGenerators4Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(Messages.Generators4Group_title);
		
		//paletteContainer.add(createGMF_Generator1CreationTool());
		// paletteContainer.add(createEMF_Generator2CreationTool());
		// paletteContainer.add(createUseit_Generator3CreationTool());
		// paletteContainer.add(createTopcasedGenerator4CreationTool());
		// paletteContainer.add(createAM3_Generator5CreationTool());
		createDynamicGenerators(paletteContainer);
		paletteContainer.add(createGeneratoruses6CreationTool());
		paletteContainer.add(createGeneratorproduce7CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates the dynamic generator tool entrys.
	 * 
	 * @param paletteContainer
	 */

	private void createDynamicGenerators(PaletteDrawer paletteContainer) {
		// PaletteStack paletteStack = new PaletteStack("test", null, null);
		

		//Collection<GeneratorDescriptor> availableGenerators = de.urszeidler.eclipse.callchain.generatorservice.Generatorservice
		//		.getDefault().generatorDescriptors();
		Map<String, Category> categorys = de.urszeidler.eclipse.callchain.generatorservice.Generatorservice
				.getDefault().getCategorys();
		Collection<Category> values = categorys.values();
		for (Category category : values) {
			if(category.getDescriptors().size()==0)
				continue;
			PaletteStack paletteStack = new PaletteStack(category.getName(), category.getDescription(), null);
			paletteContainer.add(paletteStack);
			List<GeneratorDescriptor> descriptors = category.getDescriptors();
			for (GeneratorDescriptor generatorDescriptor : descriptors) {
				List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
				IElementType elementTypes;
				types.add(CallchainElementTypes.Generic_Generator_2027);
				ElementTypeRegistry.getInstance().getType(generatorDescriptor.getId());
				GenericGeneratorToolEntry entry = new GenericGeneratorToolEntry(generatorDescriptor.getName(),
						generatorDescriptor.getDescription(), types, generatorDescriptor);
				entry.setSmallIcon(generatorDescriptor.getSmallIcon());
				entry.setLargeIcon(generatorDescriptor.getLargeIcon());
				paletteStack.add(entry);
			}
			
		}

	}

	/**
	 * @generated
	 */
	private ToolEntry createComment1CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.Comment_2024);
		NodeToolEntry entry = new NodeToolEntry(Messages.Comment1CreationTool_title,
				Messages.Comment1CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.Comment_2024));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCommentdocumentedElement2CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		LinkToolEntry entry = new LinkToolEntry(Messages.CommentdocumentedElement2CreationTool_title,
				Messages.CommentdocumentedElement2CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes
				.getImageDescriptor(CallchainElementTypes.CommentDocumentedElement_4025));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createArtifact1CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.Artifact_2020);
		NodeToolEntry entry = new NodeToolEntry(Messages.Artifact1CreationTool_title,
				Messages.Artifact1CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.Artifact_2020));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createModel2CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.Model_2015);
		NodeToolEntry entry = new NodeToolEntry(Messages.Model2CreationTool_title, Messages.Model2CreationTool_desc,
				types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.Model_2015));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAtlRes3CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.AtlRes_2016);
		NodeToolEntry entry = new NodeToolEntry(Messages.AtlRes3CreationTool_title, Messages.AtlRes3CreationTool_desc,
				types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.AtlRes_2016));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAtlLibary4CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.AtlLibary_2019);
		NodeToolEntry entry = new NodeToolEntry(Messages.AtlLibary4CreationTool_title,
				Messages.AtlLibary4CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.AtlLibary_2019));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createModelAlias5CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.ModelAlias_4016);
		LinkToolEntry entry = new LinkToolEntry(Messages.ModelAlias5CreationTool_title,
				Messages.ModelAlias5CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.ModelAlias_4016));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createMM6CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.MM_2018);
		NodeToolEntry entry = new NodeToolEntry(Messages.MM6CreationTool_title, Messages.MM6CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.MM_2018));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createModelmm7CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.ModelMm_4018);
		LinkToolEntry entry = new LinkToolEntry(Messages.Modelmm7CreationTool_title,
				Messages.Modelmm7CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.ModelMm_4018));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createMMAlias8CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.MMAlias_4017);
		LinkToolEntry entry = new LinkToolEntry(Messages.MMAlias8CreationTool_title,
				Messages.MMAlias8CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.MMAlias_4017));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCall1CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.Call_2017);
		NodeToolEntry entry = new NodeToolEntry(Messages.Call1CreationTool_title, Messages.Call1CreationTool_desc,
				types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.Call_2017));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCallin2CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.CallIn_4020);
		LinkToolEntry entry = new LinkToolEntry(Messages.Callin2CreationTool_title, Messages.Callin2CreationTool_desc,
				types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.CallIn_4020));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCallout3CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.CallOut_4021);
		LinkToolEntry entry = new LinkToolEntry(Messages.Callout3CreationTool_title,
				Messages.Callout3CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.CallOut_4021));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCallartifact4CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.CallArtifact_4024);
		LinkToolEntry entry = new LinkToolEntry(Messages.Callartifact4CreationTool_title,
				Messages.Callartifact4CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.CallArtifact_4024));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCalllibarys5CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.CallLibarys_4023);
		LinkToolEntry entry = new LinkToolEntry(Messages.Calllibarys5CreationTool_title,
				Messages.Calllibarys5CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.CallLibarys_4023));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCallres6CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.CallRes_4022);
		LinkToolEntry entry = new LinkToolEntry(Messages.Callres6CreationTool_title,
				Messages.Callres6CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.CallRes_4022));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAtlRessuperimpose7CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.AtlResSuperimpose_4019);
		LinkToolEntry entry = new LinkToolEntry(Messages.AtlRessuperimpose7CreationTool_title,
				Messages.AtlRessuperimpose7CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.AtlResSuperimpose_4019));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCallablenext8CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.CallableNext_4028);
		LinkToolEntry entry = new LinkToolEntry(Messages.Callablenext8CreationTool_title,
				Messages.Callablenext8CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.CallableNext_4028));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createGMF_Generator1CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.GMF_Generator_2026);
		NodeToolEntry entry = new NodeToolEntry(Messages.GMF_Generator1CreationTool_title,
				Messages.GMF_Generator1CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.GMF_Generator_2026));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createEMF_Generator2CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.EMF_Generator_2021);
		NodeToolEntry entry = new NodeToolEntry(Messages.EMF_Generator2CreationTool_title,
				Messages.EMF_Generator2CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.EMF_Generator_2021));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createUseit_Generator3CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.Useit_Generator_2022);
		NodeToolEntry entry = new NodeToolEntry(Messages.Useit_Generator3CreationTool_title,
				Messages.Useit_Generator3CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.Useit_Generator_2022));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createTopcasedGenerator4CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.TopcasedGenerator_2023);
		NodeToolEntry entry = new NodeToolEntry(Messages.TopcasedGenerator4CreationTool_title,
				Messages.TopcasedGenerator4CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.TopcasedGenerator_2023));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAM3_Generator5CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.AM3_Generator_2025);
		NodeToolEntry entry = new NodeToolEntry(Messages.AM3_Generator5CreationTool_title,
				Messages.AM3_Generator5CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.AM3_Generator_2025));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createGeneratoruses6CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.GeneratorUses_4026);
		LinkToolEntry entry = new LinkToolEntry(Messages.Generatoruses6CreationTool_title,
				Messages.Generatoruses6CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.GeneratorUses_4026));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createGeneratorproduce7CreationTool() {
		List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
		types.add(CallchainElementTypes.GeneratorProduce_4027);
		LinkToolEntry entry = new LinkToolEntry(Messages.Generatorproduce7CreationTool_title,
				Messages.Generatorproduce7CreationTool_desc, types);
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.GeneratorProduce_4027));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	private static class GenericGeneratorToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List elementTypes;
		private GeneratorDescriptor descriptor;

		/**
		 * @generated
		 */
		private GenericGeneratorToolEntry(String title, String description, List elementTypes,
				GeneratorDescriptor generatorDescriptor) {
			super(title, description, null, null);
			this.elementTypes = elementTypes;
			this.descriptor = generatorDescriptor;
			// setToolProperty("generator", generatorDescriptor);
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new GenericGeneratorCreationTool(elementTypes, descriptor);
			tool.setProperties(getToolProperties());

			return tool;
		}

	}

	/**
	 * @generated
	 */
	private static class NodeToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List elementTypes;

		/**
		 * @generated
		 */
		private NodeToolEntry(String title, String description, List elementTypes) {
			super(title, description, null, null);
			this.elementTypes = elementTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}

	/**
	 * @generated
	 */
	private static class LinkToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List relationshipTypes;

		/**
		 * @generated
		 */
		private LinkToolEntry(String title, String description, List relationshipTypes) {
			super(title, description, null, null);
			this.relationshipTypes = relationshipTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}
}
