package de.urszeidler.eclipse.callchain.diagram.sheet;

import java.util.ArrayList;
import java.util.Iterator;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.transaction.util.TransactionUtil;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.diagram.ui.properties.sections.AdvancedPropertySection;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.views.properties.IPropertySource;
import org.eclipse.ui.views.properties.IPropertySourceProvider;

import de.urszeidler.eclipse.callchain.propertySource.CustomPropertySource;

/**
 * @generated
 */
public class CallchainPropertySection extends AdvancedPropertySection implements
		IPropertySourceProvider {

	/**
	 * @generated not
	 */
	public IPropertySource getPropertySource(Object object) {
		if (object instanceof IPropertySource) {
			return (IPropertySource) object;
		}

		final AdapterFactory af = getAdapterFactory(object);
		if (af != null) {
			IItemPropertySource ips = (IItemPropertySource) af.adapt(object,
					IItemPropertySource.class);
			if (ips != null) {
				return new CustomPropertySource(object, ips);
				//
				//
				// return new PropertySource(object, ips) {
				// protected IPropertyDescriptor createPropertyDescriptor(
				// IItemPropertyDescriptor itemPropertyDescriptor) {
				//
				// String id = itemPropertyDescriptor.getId(this.object);
				//
				// Object adapter = af.adapt(object,
				// IItemLabelProvider.class);
				// if (adapter instanceof ItemProviderAdapter) {
				// ItemProviderAdapter pa = (ItemProviderAdapter) adapter;
				//
				// if (object instanceof AtlLibary) {
				// AtlLibary lib = (AtlLibary) object;
				// if (id.equals(pa
				// .getString("_UI_Artifact_uri_feature")))
				// return new ElementTreeSelectionDialogPropertySource(
				// object, itemPropertyDescriptor,
				// "lib");
				//
				// }//end of if (object instanceof AtlLibary)
				//
				// if (object instanceof AtlRes) {
				// AtlRes res = (AtlRes) object;
				// if (id.equals(pa
				// .getString("_UI_Artifact_uri_feature")))
				// return new ElementTreeSelectionDialogPropertySource(
				// object, itemPropertyDescriptor,
				// "atl");
				// }//end of if (object instanceof AtlRes)
				//
				// if (object instanceof Model) {
				// Model m = (Model) object;
				// if (id.equals(pa
				// .getString("_UI_Artifact_uri_feature"))) {
				// return new ElementTreeSelectionDialogPropertySource(
				// object, itemPropertyDescriptor, "");
				// }
				//
				// }//end of if (object instanceof Model)
				//
				// //object.toString();
				// if (id.equals(pa.getString("_UI_MM_uri_feature")))
				// return new EMFDialog(object,
				// itemPropertyDescriptor);
				// // return new TargetPathPropertyDescriptor(id,
				// // itemPropertyDescriptor.getDisplayName(object));
				//
				// // if(id.equals(pa.getString("_UI_Model_uri_feature"))){
				// // return new
				// ElementTreeSelectionDialogPropertySource(object,
				// itemPropertyDescriptor,"");
				// // }
				// }
				// // IPropertySource ps = super.createPropertySource(object,
				// // itemPropertySource);
				// //
				// // return ps;
				// return super
				// .createPropertyDescriptor(itemPropertyDescriptor);
				// }
				// };
			}
		}
		if (object instanceof IAdaptable) {
			return (IPropertySource) ((IAdaptable) object)
					.getAdapter(IPropertySource.class);
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected IPropertySourceProvider getPropertySourceProvider() {
		return this;
	}

	/**
	 * Modify/unwrap selection.
	 * 
	 * @generated
	 */
	protected Object transformSelection(Object selected) {

		if (selected instanceof EditPart) {
			Object model = ((EditPart) selected).getModel();
			return model instanceof View ? ((View) model).getElement() : null;
		}
		if (selected instanceof View) {
			return ((View) selected).getElement();
		}
		if (selected instanceof IAdaptable) {
			View view = (View) ((IAdaptable) selected).getAdapter(View.class);
			if (view != null) {
				return view.getElement();
			}
		}
		return selected;
	}

	/**
	 * @generated
	 */
	public void setInput(IWorkbenchPart part, ISelection selection) {
		if (selection.isEmpty()
				|| false == selection instanceof StructuredSelection) {
			super.setInput(part, selection);
			return;
		}
		final StructuredSelection structuredSelection = ((StructuredSelection) selection);
		ArrayList transformedSelection = new ArrayList(structuredSelection
				.size());
		for (Iterator it = structuredSelection.iterator(); it.hasNext();) {
			Object r = transformSelection(it.next());
			if (r != null) {
				transformedSelection.add(r);
			}
		}
		super.setInput(part, new StructuredSelection(transformedSelection));
	}

	/**
	 * @generated
	 */
	protected AdapterFactory getAdapterFactory(Object object) {
		if (getEditingDomain() instanceof AdapterFactoryEditingDomain) {
			return ((AdapterFactoryEditingDomain) getEditingDomain())
					.getAdapterFactory();
		}
		TransactionalEditingDomain editingDomain = TransactionUtil
				.getEditingDomain(object);
		if (editingDomain != null) {
			return ((AdapterFactoryEditingDomain) editingDomain)
					.getAdapterFactory();
		}
		return null;
	}

}
