/**
 * <copyright>
 * </copyright>
 *
 * $Id: TopcasedGeneratorExe.java,v 1.1 2008/04/09 22:42:50 urs Exp $
 */
package de.urszeidler.eclipse.callchain.executors;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.core.runtime.Path;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;
import org.topcased.generator.internal.GeneratorPlugin;
import org.topcased.generator.util.ConfiguratorObjectManager;
import org.topcased.java.reverse.Java2UMLConverter;
import org.topcased.modeler.diagramconfigurator.DiagramConfiguration;
import org.topcased.modeler.editorconfigurator.EditorConfiguration;
import org.topcased.modeler.generator.internal.generators.DiagramConfiguratorGenerator;
import org.topcased.modeler.generator.internal.generators.EditorConfiguratorGenerator;
import org.topcased.properties.configurator.TabbedView;
import org.topcased.properties.generator.PropertiesViewGenerator;

import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.TCGeneratorKind;
import de.urszeidler.eclipse.callchain.TopcasedGenerator;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Topcased Generator</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link de.urszeidler.eclipse.callchain.executors.TopcasedGeneratorExe#getKind <em>Kind</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 * @deprecated
 */
public class TopcasedGeneratorExe  implements ExecutorStep{
	private TopcasedGenerator generator;
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public TopcasedGeneratorExe(TopcasedGenerator generator) {
		super();
		this.generator = generator;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public void generate(Object monitor) {
		IProgressMonitor pmonitor;
		if (monitor instanceof IProgressMonitor) {
			pmonitor = (IProgressMonitor) monitor;

		}// end of if (monitor instanceof IProgressMonitor)
		else {

			pmonitor = new NullProgressMonitor();
		}

		try {

			switch (generator.getKind().getValue()) {
//			case TCGeneratorKind.OUTLINE_GENERATOR:
//				generateOutline(pmonitor);
//				break;
			case TCGeneratorKind.DIAGRAM_GENERATOR:
				generateDiagram(pmonitor);
				break;
			case TCGeneratorKind.PROPERTIES_GENERATOR:
				generateProperties(pmonitor);
				break;
			case TCGeneratorKind.EDITOR_GENERATOR:
				generateEditor(pmonitor);
				break;
			case TCGeneratorKind.UM_LIMPORTER:
				java2UML(pmonitor);
				break;

			default:
				break;
			}

		} finally {
			pmonitor.done();
		}// end of try catch

	}

	private void generateProperties(IProgressMonitor pmonitor) {
		EList models2 = generator.getUses();
		Model model = (Model) models2.get(0);

		String uri = model.getUri();
		Path file = new Path(uri);
		IWorkspace wks = ResourcesPlugin.getWorkspace();
		IWorkspaceRoot wksroot = wks.getRoot();
		IProject generatedProject = null;

		IFile currentFile = wksroot.getFile(new Path(uri));

		try {
			ConfiguratorObjectManager manager = new ConfiguratorObjectManager();
			manager.load(currentFile.getFullPath());
			// retrieve the root model object and check if it has the expected
			// type
			if (manager.getRootModelObject() instanceof TabbedView) {
				TabbedView configuration = (TabbedView) manager
						.getRootModelObject();
				pmonitor.subTask("Properties Configuration validation");
				Diagnostician diagnostician = new Diagnostician();
				Diagnostic diagnostic = diagnostician.validate(configuration);
				if (diagnostic.getSeverity() <= Diagnostic.INFO) {
					//pmonitor.worked(1);

					PropertiesViewGenerator generator = new PropertiesViewGenerator(
							configuration);
					generatedProject = generator.generate(pmonitor);
				} else {
					GeneratorPlugin
							.log(
									"Validation problem : a problem occured during the properties configuration validation.",
									IStatus.ERROR);
				}
			} else {
				GeneratorPlugin
						.log(
								"The root model object has not the right type. Generation process has been aborted.",
								IStatus.ERROR);
			}

		} catch (Exception e) {
			GeneratorPlugin.log(e);
			// GeneratorPlugin.displayDialog(null, "An error occurred during the
			// editor generation", IStatus.ERROR);
		}
		// }

	}

	private void java2UML(IProgressMonitor monitor) {
//		Artifact javacode = (Artifact) generator.getUses().get(0);
//		Artifact uml = (Artifact) generator.getProduce().get(0);
//
//		String umluri = uml.getUri();
//		IWorkspace wks = ResourcesPlugin.getWorkspace();
//		IWorkspaceRoot wksroot = wks.getRoot();
//
//		monitor.beginTask("Reverse Engineering", 5);
//
//		String modelName = uml.getName();
//		String javaname = javacode.getUri();
//		IProject project = wksroot.getProject(javaname);
//		IJavaProject jproject = JavaCore.create(project);
//
//		IFile modelFile = wksroot.getFile(new Path(umluri));
//
//		// Reverse Engineering
//		Java2UMLConverter converter = new Java2UMLConverter();
//		org.eclipse.uml2.uml.Model model;
//		try {
//			try {
//				model = converter.convert(jproject);
//				model.setName(modelName);
//				// Save reversed UML model
//				saveModelFile(model, modelFile);
//			} catch (IOException e) {
//				e.printStackTrace();
//			}
//		} catch (JavaModelException e) {
//			e.printStackTrace();
//		}finally{
//		//monitor.worked(1);
//
//		//monitor.worked(1);
//
//		//monitor.done();
//		}
	}

	private void saveModelFile(org.eclipse.uml2.uml.Model model, IFile modelFile)
			throws IOException {
		// Create a resource set
		ResourceSet resourceSet = new ResourceSetImpl();

		// Get the URI of the model file.
		URI fileURI = URI.createPlatformResourceURI(modelFile.getFullPath()
				.toString());

		// Create a resource for this file.
		Resource emfResource = resourceSet.createResource(fileURI);

		// Add the initial model object to the contents.
		if (model != null) {
			emfResource.getContents().add(model);
		}

		// Save the contents of the resource to the file
		// system.
		Map options = new HashMap();
		emfResource.save(options);
	}

	private void generateDiagram(IProgressMonitor pmonitor) {
		EList models2 = generator.getUses();
		Model model = (Model) models2.get(0);

		String uri = model.getUri();
		Path file = new Path(uri);
		IWorkspace wks = ResourcesPlugin.getWorkspace();
		IWorkspaceRoot wksroot = wks.getRoot();

		IFile currentFile = wksroot.getFile(new Path(uri));
		try {

			ConfiguratorObjectManager manager = new ConfiguratorObjectManager();
			manager.load(currentFile.getFullPath());
			// retrieve the root model object and check if it has the expected
			// type
			if (manager.getRootModelObject() instanceof DiagramConfiguration) {
				DiagramConfiguration configuration = (DiagramConfiguration) manager
						.getRootModelObject();
				DiagramConfiguratorGenerator generator = new DiagramConfiguratorGenerator(
						configuration);
				IProject generatedProject = generator.generate(pmonitor);

				// if (configuration.isOrganizeImports())
				// {
				// AbstractGenerator.organizeImports(generatedProject);
				// }
			}
		} catch (Exception e) {
			GeneratorPlugin.log(e);
			// GeneratorPlugin.displayDialog(null, "An error occurred during the
			// editor generation", IStatus.ERROR);
		}
		// }
	}

	@SuppressWarnings("restriction")
	private void generateEditor(IProgressMonitor pmonitor) {
		EList models2 = generator.getUses();
		Model model = (Model) models2.get(0);

		String uri = model.getUri();
		Path file = new Path(uri);
		IWorkspace wks = ResourcesPlugin.getWorkspace();
		IWorkspaceRoot wksroot = wks.getRoot();

		IFile currentFile = wksroot.getFile(new Path(uri));
		IProject generatedProject = null;
		EditorConfiguration configuration = null;

		try {
			try {

				ConfiguratorObjectManager manager = new ConfiguratorObjectManager();
				manager.load(currentFile.getFullPath());
				// retrieve the root model object and check if it has the
				// expected type
				if (manager.getRootModelObject() instanceof EditorConfiguration) {
					configuration = (EditorConfiguration) manager
							.getRootModelObject();
					EditorConfiguratorGenerator generator = new EditorConfiguratorGenerator(
							configuration);
					generatedProject = generator.generate(pmonitor);

				}
			} finally {
				pmonitor.done();

			}
		} catch (Exception e) {
			GeneratorPlugin.log(e);
			// GeneratorPlugin.displayDialog(null, "An error occurred during
			// the editor generation", IStatus.ERROR);
		}

		// try {
		// if (configuration != null && generatedProject != null)
		// if (configuration.isOrganizeImports()) {
		// AbstractGenerator.organizeImports(generatedProject);
		// }

		// } finally {
		//
		// }

	}

	@Override
	public String getTaskName() {
		return generator.getName();
	}


} // TopcasedGeneratorImpl
