/**
 * 
 */
package de.urszeidler.eclipse.callchain.generatorservice.wizard;

import java.io.File;
import java.net.URL;
import java.util.Locale;
import java.util.ResourceBundle;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.Platform;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.pde.core.plugin.IPluginBase;
import org.eclipse.pde.core.plugin.IPluginElement;
import org.eclipse.pde.core.plugin.IPluginExtension;
import org.eclipse.pde.core.plugin.IPluginModelBase;
import org.eclipse.pde.core.plugin.IPluginModelFactory;
import org.eclipse.pde.ui.IFieldData;
import org.eclipse.pde.ui.templates.OptionTemplateSection;
import org.osgi.framework.Bundle;

import de.urszeidler.eclipse.callchain.generatorservice.Generatorservice;

public class GenericGeneratorTemplateSection extends OptionTemplateSection {
		private static final String KEY_GEDNERATOR_CLASS_NAME = "generatorClassName";
		private static final String KEY_GENERATOR_TYPE_NAME = "generatorType";
		private static final String KEY_GENERATOR_ID = "id";

		public GenericGeneratorTemplateSection(){
			setPageCount(1);
			createOptions();
		}
		private void createOptions() {
			addOption(KEY_PACKAGE_NAME, "package name", (String) null, 0);

			addOption(KEY_GENERATOR_ID, "id", "sampleGenerator1", 0); //$NON-NLS-1$
			addOption(KEY_GEDNERATOR_CLASS_NAME, "generator class name", "SampleGenerator", 0); //$NON-NLS-1$
			addOption(KEY_GENERATOR_TYPE_NAME, "Generator type name", "sample generator", 0); //$NON-NLS-1$
			
//			addOption(KEY_BUILDER_NAME, PDETemplateMessages.BuilderTemplate_builderName, PDETemplateMessages.BuilderTemplate_defaultBuilderName, 0);
//
//			addOption(KEY_NATURE_CLASS_NAME, PDETemplateMessages.BuilderTemplate_natureClass, "SampleNature", 0); //$NON-NLS-1$
//			addOption(KEY_NATURE_ID, PDETemplateMessages.BuilderTemplate_natureId, "sampleNature", 0); //$NON-NLS-1$
//			addOption(KEY_NATURE_NAME, PDETemplateMessages.BuilderTemplate_natureName, PDETemplateMessages.BuilderTemplate_defaultNatureName, 0);
//
//			actionOption = (BooleanOption) addOption(KEY_GEN_ACTION, PDETemplateMessages.BuilderTemplate_generateAction, true, 0);
		}

		
		@Override
		public String getSectionId() {
			return "generator";
		}

		public void initializeFields(IPluginModelBase model) {
			// In the new extension wizard, the model exists so
			// we can initialize directly from it
			String pluginId = model.getPluginBase().getId();
			initializeOption(KEY_PACKAGE_NAME, getFormattedPackageName(pluginId));
			initializeOption(KEY_GENERATOR_ID,  getFormattedPackageName(pluginId)+".SampleGenrator");
		}

		protected void initializeFields(IFieldData data) {
			// In a new project wizard, we don't know this yet - the
			// model has not been created
			String id = data.getId();
			initializeOption(KEY_PACKAGE_NAME, getFormattedPackageName(id));
			initializeOption(KEY_GENERATOR_ID,  getFormattedPackageName(id)+".SampleGenrator");
		}

		public void addPages(Wizard wizard) {
			WizardPage page = createPage(0, "");
			page.setTitle("add a generator");
			page.setDescription("creates a generator");
			wizard.addPage(page);
			markPagesAdded();
		}
		protected boolean isOkToCreateFile(File sourceFile) {
			return true;
		}

		@Override
		protected void updateModel(IProgressMonitor monitor) throws CoreException {
			IPluginBase plugin = model.getPluginBase();
			IPluginModelFactory factory = model.getPluginFactory();
			
			IPluginExtension extension1 = createExtension("de.urszeidler.eclipse.callchain.generatorservice", true); //$NON-NLS-1$
			
			IPluginElement element = factory.createElement(extension1);
			element.setName("atlflowgenerator");
			element.setAttribute("id", getStringOption(KEY_GENERATOR_ID));
			element.setAttribute("typeName", getStringOption(KEY_GENERATOR_TYPE_NAME));
			element.setAttribute("className",getStringOption(KEY_PACKAGE_NAME) //$NON-NLS-1$
					+ "." +  getStringOption(KEY_GEDNERATOR_CLASS_NAME));
			extension1.add(element);
			
			if (!extension1.isInTheModel())
				plugin.add(extension1);

			
			//				
			//extension1.setId(getStringOption(KEY_BUILDER_ID));
//				extension1.setName(getStringOption(KEY_BUILDER_NAME));

		}

		@Override
		public String getUsedExtensionPoint() {
			return "de.urszeidler.eclipse.callchain.generatorservice"; //$NON-NLS-1$
		}

		protected URL getInstallURL() {
			return Generatorservice.getDefault().getInstallURL();
		}
		
		@Override
		protected String getTemplateDirectory() {
			return "templates_3.0";
		}
		
		@Override
		protected ResourceBundle getPluginResourceBundle() {
			Bundle bundle = Platform.getBundle(Generatorservice.PLUGIN_ID);
			return Platform.getResourceBundle(bundle);
		}

		protected String getFormattedPackageName(String id) {
			StringBuffer buffer = new StringBuffer();
			for (int i = 0; i < id.length(); i++) {
				char ch = id.charAt(i);
				if (buffer.length() == 0) {
					if (Character.isJavaIdentifierStart(ch))
						buffer.append(Character.toLowerCase(ch));
				} else {
					if (Character.isJavaIdentifierPart(ch) || ch == '.')
						buffer.append(ch);
				}
			}
			return buffer.toString().toLowerCase(Locale.ENGLISH);
		}

		@Override
		public String[] getNewFiles() {
			return new String[0];
		}
		

	}