/**
 * <copyright>
 * </copyright>
 *
 * $Id: CallchainFactoryImpl.java,v 1.3 2008/04/13 20:29:19 urs Exp $
 */
package de.urszeidler.eclipse.callchain.impl;

import de.urszeidler.eclipse.callchain.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class CallchainFactoryImpl extends EFactoryImpl implements CallchainFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static CallchainFactory init() {
		try {
			CallchainFactory theCallchainFactory = (CallchainFactory)EPackage.Registry.INSTANCE.getEFactory("http://urszeidler.de/callchain/2008/flowmodel"); 
			if (theCallchainFactory != null) {
				return theCallchainFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new CallchainFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallchainFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case CallchainPackage.MODEL: return createModel();
			case CallchainPackage.ATL_RES: return createAtlRes();
			case CallchainPackage.CALL: return createCall();
			case CallchainPackage.MM: return createMM();
			case CallchainPackage.CALLS: return createCalls();
			case CallchainPackage.ATL_LIBARY: return createAtlLibary();
			case CallchainPackage.MODEL_ALIAS: return createModelAlias();
			case CallchainPackage.ARTIFACT: return createArtifact();
			case CallchainPackage.EMF_GENERATOR: return createEMF_Generator();
			case CallchainPackage.USEIT_GENERATOR: return createUseit_Generator();
			case CallchainPackage.TOPCASED_GENERATOR: return createTopcasedGenerator();
			case CallchainPackage.MM_ALIAS: return createMMAlias();
			case CallchainPackage.COMMENT: return createComment();
			case CallchainPackage.AM3_GENERATOR: return createAM3_Generator();
			case CallchainPackage.GMF_GENERATOR: return createGMF_Generator();
			case CallchainPackage.GENERIC_GENERATOR: return createGeneric_Generator();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case CallchainPackage.MMHANDLER:
				return createMMhandlerFromString(eDataType, initialValue);
			case CallchainPackage.TC_GENERATOR_KIND:
				return createTCGeneratorKindFromString(eDataType, initialValue);
			case CallchainPackage.EMF_GENERATOR_KIND:
				return createEMFGeneratorKindFromString(eDataType, initialValue);
			case CallchainPackage.AM3_GENERATOR_KIND:
				return createAM3GeneratorKindFromString(eDataType, initialValue);
			case CallchainPackage.GMF_GENERATOR_KIND:
				return createGMFGeneratorKindFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case CallchainPackage.MMHANDLER:
				return convertMMhandlerToString(eDataType, instanceValue);
			case CallchainPackage.TC_GENERATOR_KIND:
				return convertTCGeneratorKindToString(eDataType, instanceValue);
			case CallchainPackage.EMF_GENERATOR_KIND:
				return convertEMFGeneratorKindToString(eDataType, instanceValue);
			case CallchainPackage.AM3_GENERATOR_KIND:
				return convertAM3GeneratorKindToString(eDataType, instanceValue);
			case CallchainPackage.GMF_GENERATOR_KIND:
				return convertGMFGeneratorKindToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Model createModel() {
		ModelImpl model = new ModelImpl();
		return model;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AtlRes createAtlRes() {
		AtlResImpl atlRes = new AtlResImpl();
		return atlRes;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Call createCall() {
		CallImpl call = new CallImpl();
		return call;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MM createMM() {
		MMImpl mm = new MMImpl();
		return mm;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Calls createCalls() {
		CallsImpl calls = new CallsImpl();
		return calls;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AtlLibary createAtlLibary() {
		AtlLibaryImpl atlLibary = new AtlLibaryImpl();
		return atlLibary;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModelAlias createModelAlias() {
		ModelAliasImpl modelAlias = new ModelAliasImpl();
		return modelAlias;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Artifact createArtifact() {
		ArtifactImpl artifact = new ArtifactImpl();
		return artifact;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EMF_Generator createEMF_Generator() {
		EMF_GeneratorImpl emF_Generator = new EMF_GeneratorImpl();
		return emF_Generator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Useit_Generator createUseit_Generator() {
		Useit_GeneratorImpl useit_Generator = new Useit_GeneratorImpl();
		return useit_Generator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TopcasedGenerator createTopcasedGenerator() {
		TopcasedGeneratorImpl topcasedGenerator = new TopcasedGeneratorImpl();
		return topcasedGenerator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MMAlias createMMAlias() {
		MMAliasImpl mmAlias = new MMAliasImpl();
		return mmAlias;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Comment createComment() {
		CommentImpl comment = new CommentImpl();
		return comment;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AM3_Generator createAM3_Generator() {
		AM3_GeneratorImpl am3_Generator = new AM3_GeneratorImpl();
		return am3_Generator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GMF_Generator createGMF_Generator() {
		GMF_GeneratorImpl gmF_Generator = new GMF_GeneratorImpl();
		return gmF_Generator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Generic_Generator createGeneric_Generator() {
		Generic_GeneratorImpl generic_Generator = new Generic_GeneratorImpl();
		return generic_Generator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MMhandler createMMhandlerFromString(EDataType eDataType, String initialValue) {
		MMhandler result = MMhandler.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertMMhandlerToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TCGeneratorKind createTCGeneratorKindFromString(EDataType eDataType, String initialValue) {
		TCGeneratorKind result = TCGeneratorKind.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertTCGeneratorKindToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EMFGeneratorKind createEMFGeneratorKindFromString(EDataType eDataType, String initialValue) {
		EMFGeneratorKind result = EMFGeneratorKind.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertEMFGeneratorKindToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AM3GeneratorKind createAM3GeneratorKindFromString(EDataType eDataType, String initialValue) {
		AM3GeneratorKind result = AM3GeneratorKind.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertAM3GeneratorKindToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GMFGeneratorKind createGMFGeneratorKindFromString(EDataType eDataType, String initialValue) {
		GMFGeneratorKind result = GMFGeneratorKind.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertGMFGeneratorKindToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallchainPackage getCallchainPackage() {
		return (CallchainPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static CallchainPackage getPackage() {
		return CallchainPackage.eINSTANCE;
	}

} //CallchainFactoryImpl
