/**
 * <copyright>
 * </copyright>
 *
 * $Id: CallchainItemProviderAdapterFactory.java,v 1.2 2008/04/13 20:27:38 urs Exp $
 */
package de.urszeidler.eclipse.callchain.provider;

import de.urszeidler.eclipse.callchain.util.CallchainAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class CallchainItemProviderAdapterFactory extends CallchainAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallchainItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.Model} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelItemProvider modelItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.Model}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createModelAdapter() {
		if (modelItemProvider == null) {
			modelItemProvider = new ModelItemProvider(this);
		}

		return modelItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.AtlRes} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AtlResItemProvider atlResItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.AtlRes}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAtlResAdapter() {
		if (atlResItemProvider == null) {
			atlResItemProvider = new AtlResItemProvider(this);
		}

		return atlResItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.Call} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CallItemProvider callItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.Call}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCallAdapter() {
		if (callItemProvider == null) {
			callItemProvider = new CallItemProvider(this);
		}

		return callItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.MM} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MMItemProvider mmItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.MM}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMMAdapter() {
		if (mmItemProvider == null) {
			mmItemProvider = new MMItemProvider(this);
		}

		return mmItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.Calls} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CallsItemProvider callsItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.Calls}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCallsAdapter() {
		if (callsItemProvider == null) {
			callsItemProvider = new CallsItemProvider(this);
		}

		return callsItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.AtlLibary} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AtlLibaryItemProvider atlLibaryItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.AtlLibary}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAtlLibaryAdapter() {
		if (atlLibaryItemProvider == null) {
			atlLibaryItemProvider = new AtlLibaryItemProvider(this);
		}

		return atlLibaryItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.ModelAlias} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelAliasItemProvider modelAliasItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.ModelAlias}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createModelAliasAdapter() {
		if (modelAliasItemProvider == null) {
			modelAliasItemProvider = new ModelAliasItemProvider(this);
		}

		return modelAliasItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.Artifact} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ArtifactItemProvider artifactItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.Artifact}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createArtifactAdapter() {
		if (artifactItemProvider == null) {
			artifactItemProvider = new ArtifactItemProvider(this);
		}

		return artifactItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.EMF_Generator} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EMF_GeneratorItemProvider emF_GeneratorItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.EMF_Generator}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEMF_GeneratorAdapter() {
		if (emF_GeneratorItemProvider == null) {
			emF_GeneratorItemProvider = new EMF_GeneratorItemProvider(this);
		}

		return emF_GeneratorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.Useit_Generator} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Useit_GeneratorItemProvider useit_GeneratorItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.Useit_Generator}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createUseit_GeneratorAdapter() {
		if (useit_GeneratorItemProvider == null) {
			useit_GeneratorItemProvider = new Useit_GeneratorItemProvider(this);
		}

		return useit_GeneratorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.TopcasedGenerator} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TopcasedGeneratorItemProvider topcasedGeneratorItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.TopcasedGenerator}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTopcasedGeneratorAdapter() {
		if (topcasedGeneratorItemProvider == null) {
			topcasedGeneratorItemProvider = new TopcasedGeneratorItemProvider(this);
		}

		return topcasedGeneratorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.MMAlias} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MMAliasItemProvider mmAliasItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.MMAlias}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMMAliasAdapter() {
		if (mmAliasItemProvider == null) {
			mmAliasItemProvider = new MMAliasItemProvider(this);
		}

		return mmAliasItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.Comment} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CommentItemProvider commentItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.Comment}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCommentAdapter() {
		if (commentItemProvider == null) {
			commentItemProvider = new CommentItemProvider(this);
		}

		return commentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.AM3_Generator} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AM3_GeneratorItemProvider am3_GeneratorItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.AM3_Generator}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAM3_GeneratorAdapter() {
		if (am3_GeneratorItemProvider == null) {
			am3_GeneratorItemProvider = new AM3_GeneratorItemProvider(this);
		}

		return am3_GeneratorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.GMF_Generator} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GMF_GeneratorItemProvider gmF_GeneratorItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.GMF_Generator}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createGMF_GeneratorAdapter() {
		if (gmF_GeneratorItemProvider == null) {
			gmF_GeneratorItemProvider = new GMF_GeneratorItemProvider(this);
		}

		return gmF_GeneratorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.Generic_Generator} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Generic_GeneratorItemProvider generic_GeneratorItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.Generic_Generator}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createGeneric_GeneratorAdapter() {
		if (generic_GeneratorItemProvider == null) {
			generic_GeneratorItemProvider = new Generic_GeneratorItemProvider(this);
		}

		return generic_GeneratorItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (modelItemProvider != null) modelItemProvider.dispose();
		if (atlResItemProvider != null) atlResItemProvider.dispose();
		if (callItemProvider != null) callItemProvider.dispose();
		if (mmItemProvider != null) mmItemProvider.dispose();
		if (callsItemProvider != null) callsItemProvider.dispose();
		if (atlLibaryItemProvider != null) atlLibaryItemProvider.dispose();
		if (modelAliasItemProvider != null) modelAliasItemProvider.dispose();
		if (artifactItemProvider != null) artifactItemProvider.dispose();
		if (emF_GeneratorItemProvider != null) emF_GeneratorItemProvider.dispose();
		if (useit_GeneratorItemProvider != null) useit_GeneratorItemProvider.dispose();
		if (topcasedGeneratorItemProvider != null) topcasedGeneratorItemProvider.dispose();
		if (mmAliasItemProvider != null) mmAliasItemProvider.dispose();
		if (commentItemProvider != null) commentItemProvider.dispose();
		if (am3_GeneratorItemProvider != null) am3_GeneratorItemProvider.dispose();
		if (gmF_GeneratorItemProvider != null) gmF_GeneratorItemProvider.dispose();
		if (generic_GeneratorItemProvider != null) generic_GeneratorItemProvider.dispose();
	}

}
