package de.urszeidler.eclipse.callchain.tabbedpropery.sections;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecoretools.tabbedproperties.AbstractTabbedPropertySheetPage;
import org.eclipse.emf.ecoretools.tabbedproperties.providers.TabbedPropertiesLabelProvider;
import org.eclipse.emf.ecoretools.tabbedproperties.sections.AbstractReferencePropertySection;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.jface.viewers.IBaseLabelProvider;

import de.urszeidler.eclipse.callchain.AtlRes;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.provider.CallchainItemProviderAdapterFactory;

/**
 * A section which displays the multi features.<br>
 * The section features a table with two buttons letting the user to<br>
 * add or remove items from the selected object.
 *
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 *
 * @generated
 */
public class AtlResSuperimposeSection extends AbstractReferencePropertySection {

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     *
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getLabelText()
     * @generated
     */
    protected String getLabelText() {
        return "Superimpose:";
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     *
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getFeature()
     * @generated
     */
    protected EStructuralFeature getFeature() {
        return CallchainPackage.eINSTANCE.getAtlRes_Superimpose();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     *
     * @see org.topcased.tabbedproperties.sections.AbstractListPropertySection#getListValues()
     * @generated
     */
    protected Object getListValues() {
        return ((AtlRes) getEObject()).getSuperimpose();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     *
     * @see org.topcased.tabbedproperties.sections.AbstractListPropertySection#getLabelProvider()
     * @generated
     */
    protected IBaseLabelProvider getLabelProvider() {
        if (getFeature() instanceof EReference) {
            List f = new ArrayList();
            f.add(new CallchainItemProviderAdapterFactory());
            f.addAll(AbstractTabbedPropertySheetPage
                    .getPrincipalAdapterFactories());
            return new TabbedPropertiesLabelProvider(
                    new ComposedAdapterFactory(f));
        }
        return null;
    }
}