/*
 * (c) urs zeidler
 */
package de.urszeidler.eclipse.callchain.ui.emf.actions;

import org.eclipse.core.resources.WorkspaceJob;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;

import de.urszeidler.eclipse.callchain.GMF_Generator;
import de.urszeidler.eclipse.callchain.Generator;
import de.urszeidler.eclipse.callchain.util.CallchainSwitch;

/**
 * <p>
 * ExecuteGenerator
 * </p>
 * Created : 14.05.2007
 * 
 * @author urs
 * @version $Revision: 1.2 $, $Id: ExecuteGenerator.java,v 1.2 2007/05/14
 *          15:45:29 urs Exp $
 */
public class ExecuteGenerator extends SelectionAction {

	public static final String ID = "ExecuteGenerator";

	public ExecuteGenerator(IWorkbenchPart page) {
		super(page);
	}

	public ExecuteGenerator(String text, ImageDescriptor image) {
		super(text, image);
	}

	public ExecuteGenerator(String text, int style) {
		super(text, style);
	}

	public ExecuteGenerator(String text) {
		super(text);
		//        
		// super(text, ExtendedImageRegistry.getInstance().getImageDescriptor(
		// CallchainEditPlugin.getPlugin().getImage("generate")));

		initAction();

	}

	/**
     * 
     */
	protected void initAction() {
		setId(ID);
		setActionDefinitionId("executeGenerator");
	}

	public ExecuteGenerator() {
		this("generate");
	}

	public ExecuteGenerator(IWorkbenchPage workbenchPage) {
		this();
		setWPart(workbenchPage.getActivePart());
	}

	public boolean isEnabled() {
		if (selection == null)
			return true;

		return (selection instanceof Generator);
	}

	@Override
	public void run() {
		final Generator gen = (Generator) selection;
		//a hack for the gmf genrator
		if (gen instanceof GMF_Generator) {
			GMF_Generator gmfgen = (GMF_Generator) gen;
			CallchainDoGenerationSwitch swt = new CallchainDoGenerationSwitch();
			swt.doSwitch(gen);

		} else {

			Job job = new WorkspaceJob("execute generator: " + gen.getName()) {
				public IStatus runInWorkspace(IProgressMonitor monitor) {

					CallchainDoGenerationSwitch swt = new CallchainDoGenerationSwitch();
					swt.setMonitor(monitor);
					swt.doSwitch(gen);
					return new Status(IStatus.OK,
							"de.urszeidler.eclipse.callchain.ui", "executed ok");
				}

			};
			job.setUser(true);
			job.schedule();
		}
	}

}
