/*
 * (c) urs zeidler
 */
package de.urszeidler.eclipse.callchain.ui.emf.actions;

import org.eclipse.emf.edit.ui.provider.ExtendedImageRegistry;
import org.eclipse.ui.IWorkbenchPage;

import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.executors.MCcallchain;
import de.urszeidler.eclipse.callchain.provider.CallchainEditPlugin;

/**
 * 
 * <p> 
 * ExecuteCallAction 
 * </p> 
 * Created : 23.04.2007 
 * @author urs 
 * @version $Revision: 1.1 $, $Id: ExecuteSingleCallAction.java,v 1.1 2008/04/24 11:40:54 urs Exp $
 */
public class ExecuteSingleCallAction extends SelectionAction {
    public static final String ID = "ExecuteSingleCallAction";


	public ExecuteSingleCallAction() {
        this("Execute Single Transformation");
    }
    public ExecuteSingleCallAction(String text) {
        super(text,ExtendedImageRegistry.getInstance().getImageDescriptor(CallchainEditPlugin.getPlugin().getImage("build")));
        
        
    }
     public ExecuteSingleCallAction(IWorkbenchPage workbenchPage) {
    	 this("Execute Single Transformation");
    	 setWPart(workbenchPage.getActivePart());
	}
	@Override
    protected void initAction() {
        setId(ID);
        setActionDefinitionId("ExecuteSingleCallAction");
        
    }
//    
//    @Override
//    public String getText() {
//       return "ExecuteCallAction";
//    }
    
    public boolean isEnabled() {
        if( selection==null)
        	return true;
        
        return (selection instanceof Call) ;
    }

    
    @Override
    public void run() {
                   MCcallchain ccallchain = new MCcallchain();
                    ccallchain.startSingleTransformation((Call) selection);
                             
    }
}
