/*******************************************************************************
 * urs zeidler
 ******************************************************************************/
package de.urszeidler.eclipse.callchain.ui.wizards;

import java.net.MalformedURLException;

import org.eclipse.core.resources.IContainer;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.ide.IDE;

import de.urszeidler.eclipse.callchain.provider.CallchainEditPlugin;

/**
 * Generated wizard that offers the model creation facilities.
 * 
 * @generated
 */
public class NewCallchainDiagrams_TCdiagram extends BasicTemplateWizard {
	private static final String BASE_BUNDEL_ENTRY = "/templates/Editor_and_Diagram_from_Genmodel";

	private IStructuredSelection selection;
	private CallchainSimpleTemplatePage diagPage;
	private IFile createdFile;

	/**
	 * @see org.eclipse.ui.IWorkbenchWizard#init(org.eclipse.ui.IWorkbench,
	 *      org.eclipse.jface.viewers.IStructuredSelection)
	 */
	public void init(IWorkbench workbench, IStructuredSelection sel) {
		createdFile = null;
		selection = sel;

		// TODO put the Wizard image
		// setDefaultPageImageDescriptor(CallchainImageRegistry
		// .getImageDescriptor("NEW_PAGE_WZD"));
		setDialogSettings(WizardsPlugin.getDefault().getDialogSettings());
		setWindowTitle("Create new Callchain diagrams");

	}

	/**
	 * @see org.eclipse.jface.wizard.IWizard#performFinish()
	 */
	public boolean performFinish() {
		boolean result = true;
		if (diagPage.isPageComplete()) {
			try {
				result = result & createFilesFromTemplate();

			} catch (CoreException e) {
				CallchainEditPlugin.log(e);
			} catch (MalformedURLException e) {
				CallchainEditPlugin.log(e);
			}
			// result = result & createDiagramFile();
			if (createdFile != null && result) {
				// Open the newly created model
				try {
					IDE.openEditor(WizardsPlugin.getDefault().getWorkbench()
							.getActiveWorkbenchWindow().getActivePage(),
							createdFile, true);
				} catch (PartInitException pie) {
					CallchainEditPlugin.log(pie);
				}
			}
			if (diagPage.isAddAltNature())
				addATLnature(null, diagPage.getNatureType());
		}
		return result;
	}

	/**
	 * @see org.eclipse.jface.wizard.IWizard#addPages()
	 */
	public void addPages() {
		diagPage = new CallchainSimpleTemplatePage("New gmf diagram editor",
				selection, "ecore");
		diagPage.setTitle("Callchain Diagrams");
		diagPage.setDescription("Select your ecore input model.");
		diagPage.setFileExtension("callchain");
		diagPage.setSourceFileExtension("ecore");
		addPage(diagPage);
	}

	public boolean canFinish() {
		return diagPage.isPageComplete();
	}

	protected IContainer getTargetContainer() {
		return diagPage.getSelectedIContainer();
	}

	protected String getModelName() {
		return diagPage.getModelName();
	}

	protected String getBaseTemplatePath() {
		return BASE_BUNDEL_ENTRY;
	}

	@Override
	protected String getProjectName() {
		return diagPage.getProjectName();
	}
}
