/**
 * <copyright>
 * </copyright>
 *
 * $Id: CallchainValidator.java,v 1.2 2008/04/13 20:29:20 urs Exp $
 */
package de.urszeidler.eclipse.callchain.util;

import de.urszeidler.eclipse.callchain.*;
import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Map;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.Path;
import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.plugin.EcorePlugin;
import org.eclipse.emf.ecore.util.EObjectValidator;

import de.urszeidler.eclipse.callchain.AM3GeneratorKind;
import de.urszeidler.eclipse.callchain.AM3_Generator;
import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.AtlLibary;
import de.urszeidler.eclipse.callchain.AtlRes;
import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.Callable;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.Comment;
import de.urszeidler.eclipse.callchain.Documentable;
import de.urszeidler.eclipse.callchain.EMFGeneratorKind;
import de.urszeidler.eclipse.callchain.EMF_Generator;
import de.urszeidler.eclipse.callchain.Generator;
import de.urszeidler.eclipse.callchain.MM;
import de.urszeidler.eclipse.callchain.MMAlias;
import de.urszeidler.eclipse.callchain.MMhandler;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.ModelAlias;
import de.urszeidler.eclipse.callchain.TCGeneratorKind;
import de.urszeidler.eclipse.callchain.TopcasedGenerator;
import de.urszeidler.eclipse.callchain.Useit_Generator;

/**
 * <!-- begin-user-doc --> The <b>Validator</b> for the model. <!-- end-user-doc
 * -->
 * 
 * @see de.urszeidler.eclipse.callchain.CallchainPackage
 * @generated
 */
@SuppressWarnings("unchecked")
public class CallchainValidator extends EObjectValidator {
	public static List EXTENSIONS = new ArrayList();
	static {
		EXTENSIONS.add("atl");
		EXTENSIONS.add("acg");
	}

	/**
	 * The cached model package <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final CallchainValidator INSTANCE = new CallchainValidator();

	/**
	 * A constant for the
	 * {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of
	 * diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes}
	 * from this package. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.emf.common.util.Diagnostic#getSource()
	 * @see org.eclipse.emf.common.util.Diagnostic#getCode()
	 * @generated
	 */
	public static final String DIAGNOSTIC_SOURCE = "de.urszeidler.eclipse.callchain";

	/**
	 * A constant with a fixed name that can be used as the base value for
	 * additional hand written constants. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 0;

	/**
	 * A constant with a fixed name that can be used as the base value for
	 * additional hand written constants in a derived class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

	/**
	 * Creates an instance of the switch. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public CallchainValidator() {
		super();
	}

	/**
	 * Returns the package of this validator switch. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EPackage getEPackage() {
		return CallchainPackage.eINSTANCE;
	}

	/**
	 * Calls <code>validateXXX</code> for the corresponding classifier of the
	 * model. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected boolean validate(int classifierID, Object value, DiagnosticChain diagnostics, Map<Object, Object> context) {
		switch (classifierID) {
		case CallchainPackage.MODEL:
			return validateModel((Model) value, diagnostics, context);
		case CallchainPackage.ATL_RES:
			return validateAtlRes((AtlRes) value, diagnostics, context);
		case CallchainPackage.CALL:
			return validateCall((Call) value, diagnostics, context);
		case CallchainPackage.MM:
			return validateMM((MM) value, diagnostics, context);
		case CallchainPackage.CALLS:
			return validateCalls((Calls) value, diagnostics, context);
		case CallchainPackage.ATL_LIBARY:
			return validateAtlLibary((AtlLibary) value, diagnostics, context);
		case CallchainPackage.MODEL_ALIAS:
			return validateModelAlias((ModelAlias) value, diagnostics, context);
		case CallchainPackage.GENERATOR:
			return validateGenerator((Generator) value, diagnostics, context);
		case CallchainPackage.ARTIFACT:
			return validateArtifact((Artifact) value, diagnostics, context);
		case CallchainPackage.EMF_GENERATOR:
			return validateEMF_Generator((EMF_Generator) value, diagnostics, context);
		case CallchainPackage.USEIT_GENERATOR:
			return validateUseit_Generator((Useit_Generator) value, diagnostics, context);
		case CallchainPackage.TOPCASED_GENERATOR:
			return validateTopcasedGenerator((TopcasedGenerator) value, diagnostics, context);
		case CallchainPackage.MM_ALIAS:
			return validateMMAlias((MMAlias) value, diagnostics, context);
		case CallchainPackage.DOCUMENTABLE:
			return validateDocumentable((Documentable) value, diagnostics, context);
		case CallchainPackage.COMMENT:
			return validateComment((Comment) value, diagnostics, context);
		case CallchainPackage.AM3_GENERATOR:
			return validateAM3_Generator((AM3_Generator) value, diagnostics, context);
		case CallchainPackage.CALLABLE:
			return validateCallable((Callable) value, diagnostics, context);
		case CallchainPackage.GMF_GENERATOR:
			return validateGMF_Generator((GMF_Generator) value, diagnostics, context);
		case CallchainPackage.GENERIC_GENERATOR:
			return validateGeneric_Generator((Generic_Generator) value, diagnostics, context);
		case CallchainPackage.MMHANDLER:
			return validateMMhandler((MMhandler) value, diagnostics, context);
		case CallchainPackage.TC_GENERATOR_KIND:
			return validateTCGeneratorKind((TCGeneratorKind) value, diagnostics, context);
		case CallchainPackage.EMF_GENERATOR_KIND:
			return validateEMFGeneratorKind((EMFGeneratorKind) value, diagnostics, context);
		case CallchainPackage.AM3_GENERATOR_KIND:
			return validateAM3GeneratorKind((AM3GeneratorKind) value, diagnostics, context);
		case CallchainPackage.GMF_GENERATOR_KIND:
			return validateGMFGeneratorKind((GMFGeneratorKind) value, diagnostics, context);
		default:
			return true;
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateModel(Model model, DiagnosticChain diagnostics, Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(model, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(model, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(model, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(model, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(model, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(model, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(model, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateModel_isUriValid(model, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateModel_isNameSet(model, diagnostics, context);
		return result;
	}

	/**
	 * Validates the isUriValid constraint of '<em>Model</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateModel_isUriValid(Model model, DiagnosticChain diagnostics, Map context) {
		if (!fileNameToURLValid(model.getUri())) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
						.getString("_UI_GenericConstraint_diagnostic", new Object[] { "isUriValid",
								getObjectLabel(model, context) }), new Object[] { model }));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the isNameSet constraint of '<em>Model</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateModel_isNameSet(Model model, DiagnosticChain diagnostics, Map context) {
		if (model.getName() == null) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
						.getString("_UI_GenericConstraint_diagnostic", new Object[] { "isNameSet",
								getObjectLabel(model, context) }), new Object[] { model }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateAtlRes(AtlRes atlRes, DiagnosticChain diagnostics, Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(atlRes, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(atlRes, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(atlRes, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(atlRes, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(atlRes, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(atlRes, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(atlRes, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateAtlRes_isUriValid(atlRes, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateAtlRes_isNameSet(atlRes, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateAtlRes_fileExist(atlRes, diagnostics, context);
		return result;
	}

	/**
	 * Validates the isUriValid constraint of '<em>Atl Res</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateAtlRes_isUriValid(AtlRes atlRes, DiagnosticChain diagnostics, Map context) {
		if (!isASMFileValid(atlRes.getUri())) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
						.getString("_UI_GenericConstraint_diagnostic", new Object[] { "isUriValid",
								getObjectLabel(atlRes, context) }), new Object[] { atlRes }));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the isNameSet constraint of '<em>Atl Res</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateAtlRes_isNameSet(AtlRes atlRes, DiagnosticChain diagnostics, Map context) {
		if (atlRes.getName() == null) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
						.getString("_UI_GenericConstraint_diagnostic", new Object[] { "isNameSet",
								getObjectLabel(atlRes, context) }), new Object[] { atlRes }));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the fileExist constraint of '<em>Atl Res</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateAtlRes_fileExist(AtlRes atlRes, DiagnosticChain diagnostics, Map context) {
		if (!atlFileExist(atlRes.getUri())) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
						.getString("_UI_GenericConstraint_diagnostic", new Object[] { "fileExist",
								getObjectLabel(atlRes, context) }), new Object[] { atlRes }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateCall(Call call, DiagnosticChain diagnostics, Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(call, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(call, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(call, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(call, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(call, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(call, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(call, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateCall_noCircularDefinition(call, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateCall_usesEnviorementLib(call, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateCall_usesEviorementSuperimposed(call, diagnostics, context);
		return result;
	}

	/**
	 * Validates the noCircularDefinition constraint of '<em>Call</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateCall_noCircularDefinition(Call call, DiagnosticChain diagnostics, Map context) {
		boolean notFound = true;
		HashSet<Object> set = new HashSet<Object>();
		set.add(call);
		Callable newcall = call.getNext();
		while (newcall != null && notFound) {
			notFound = set.add(newcall);
			newcall = newcall.getNext();
		}

		if (!notFound) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
						.getString("_UI_GenericConstraint_diagnostic", new Object[] { "noCircularDefinition",
								getObjectLabel(call, context) }), new Object[] { call }));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the usesEnviorementLib constraint of '<em>Call</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateCall_usesEnviorementLib(Call call, DiagnosticChain diagnostics, Map<Object, Object> context) {
		// TODO implement the constraint
		// -> specify the condition that violates the constraint
		// -> verify the diagnostic details, including severity, code, and
		// message
		// Ensure that you remove @generated or mark it @generated NOT
		if (false) {
			if (diagnostics != null) {
				diagnostics.add(createDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0,
						"_UI_GenericConstraint_diagnostic", new Object[] { "usesEnviorementLib",
								getObjectLabel(call, context) }, new Object[] { call }, context));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the usesEviorementSuperimposed constraint of '<em>Call</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateCall_usesEviorementSuperimposed(Call call, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		// TODO implement the constraint
		// -> specify the condition that violates the constraint
		// -> verify the diagnostic details, including severity, code, and
		// message
		// Ensure that you remove @generated or mark it @generated NOT
		if (false) {
			if (diagnostics != null) {
				diagnostics.add(createDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0,
						"_UI_GenericConstraint_diagnostic", new Object[] { "usesEviorementSuperimposed",
								getObjectLabel(call, context) }, new Object[] { call }, context));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateMM(MM mm, DiagnosticChain diagnostics, Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(mm, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(mm, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(mm, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(mm, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(mm, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(mm, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(mm, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateMM_isUriValid(mm, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateMM_isNameSet(mm, diagnostics, context);
		return result;
	}

	/**
	 * Validates the isUriValid constraint of '<em>MM</em>'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateMM_isUriValid(MM mm, DiagnosticChain diagnostics, Map<Object, Object> context) {
		// TODO implement the constraint
		// -> specify the condition that violates the constraint
		// -> verify the diagnostic details, including severity, code, and
		// message
		// Ensure that you remove @generated or mark it @generated NOT
		if (false) {
			if (diagnostics != null) {
				diagnostics.add(createDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0,
						"_UI_GenericConstraint_diagnostic", new Object[] { "isUriValid", getObjectLabel(mm, context) },
						new Object[] { mm }, context));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the isNameSet constraint of '<em>MM</em>'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateMM_isNameSet(MM mm, DiagnosticChain diagnostics, Map context) {
		if (mm.getName() == null) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
						.getString("_UI_GenericConstraint_diagnostic", new Object[] { "isNameSet",
								getObjectLabel(mm, context) }), new Object[] { mm }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateCalls(Calls calls, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(calls, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateAtlLibary(AtlLibary atlLibary, DiagnosticChain diagnostics, Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(atlLibary, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(atlLibary, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(atlLibary, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(atlLibary, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(atlLibary, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(atlLibary, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(atlLibary, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateAtlLibary_isUriValid(atlLibary, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateAtlLibary_isNameSet(atlLibary, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateAtlLibary_isASMfile(atlLibary, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateAtlLibary_fileExist(atlLibary, diagnostics, context);
		return result;
	}

	/**
	 * Validates the isUriValid constraint of '<em>Atl Libary</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateAtlLibary_isUriValid(AtlLibary atlLibary, DiagnosticChain diagnostics, Map context) {
		if (!fileNameToURLValid(atlLibary.getUri())) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
						.getString("_UI_GenericConstraint_diagnostic", new Object[] { "isUriValid",
								getObjectLabel(atlLibary, context) }), new Object[] { atlLibary }));
			}
			return false;
		}
		return true;// validateAtlRes_isUriValid(atlLibary, diagnostics,
					// context);
	}

	/**
	 * Validates the isNameSet constraint of '<em>Atl Libary</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateAtlLibary_isNameSet(AtlLibary atlLibary, DiagnosticChain diagnostics, Map context) {
		if (atlLibary.getName() == null) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
						.getString("_UI_GenericConstraint_diagnostic", new Object[] { "isNameSet",
								getObjectLabel(atlLibary, context) }), new Object[] { atlLibary }));
			}
			return false;
		}
		return true;// validateAtlRes_isNameSet(atlLibary, diagnostics,
					// context);
	}

	/**
	 * Validates the isASMfile constraint of '<em>Atl Libary</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public boolean validateAtlLibary_isASMfile(AtlLibary atlLibary, DiagnosticChain diagnostics, Map context) {
		if (!asmFileExist(atlLibary.getUri())) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
						.getString("_UI_GenericConstraint_diagnostic", new Object[] { "isASMfile",
								getObjectLabel(atlLibary, context) }), new Object[] { atlLibary }));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the fileExist constraint of '<em>Atl Libary</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateAtlLibary_fileExist(AtlLibary atlLibary, DiagnosticChain diagnostics, Map context) {
		if (!fileExist(atlLibary.getUri())) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
						.getString("_UI_GenericConstraint_diagnostic", new Object[] { "fileExist",
								getObjectLabel(atlLibary, context) }), new Object[] { atlLibary }));
			}
			return false;
		}
		return true;// validateAtlRes_fileExist(atlLibary, diagnostics,
					// context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateModelAlias(ModelAlias modelAlias, DiagnosticChain diagnostics, Map context) {
		boolean result = true;// validate_EveryMultiplicityConforms(modelAlias,
		// diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(modelAlias, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(modelAlias, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(modelAlias, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateModelAlias_isMMset(modelAlias, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateModelAlias_isUriset(modelAlias, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateModelAlias_isAliasset(modelAlias, diagnostics, context);
		return result;
	}

	/**
	 * Validates the isMMset constraint of '<em>Model Alias</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateModelAlias_isMMset(ModelAlias modelAlias, DiagnosticChain diagnostics, Map context) {
		if (modelAlias.getDecoratedmodel().getMm() == null) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
						.getString("_UI_GenericConstraint_diagnostic", new Object[] { "isMMset",
								getObjectLabel(modelAlias, context) }), new Object[] { modelAlias }));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the isUriset constraint of '<em>Model Alias</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateModelAlias_isUriset(ModelAlias modelAlias, DiagnosticChain diagnostics, Map context) {
		if (modelAlias.getDecoratedmodel().getMm().getUri() == null) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
						.getString("_UI_GenericConstraint_diagnostic", new Object[] { "isUriset",
								getObjectLabel(modelAlias, context) }), new Object[] { modelAlias }));
			}
			return false;
		}
		return true;
	}

	/**
	 * Validates the isAliasset constraint of '<em>Model Alias</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	public boolean validateModelAlias_isAliasset(ModelAlias modelAlias, DiagnosticChain diagnostics, Map context) {
		if (modelAlias.getAliasName() == null) {
			if (diagnostics != null) {
				diagnostics.add(new BasicDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0, EcorePlugin.INSTANCE
						.getString("_UI_GenericConstraint_diagnostic", new Object[] { "isAliasset",
								getObjectLabel(modelAlias, context) }), new Object[] { modelAlias }));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateGenerator(Generator generator, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(generator, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateArtifact(Artifact artifact, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(artifact, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateEMF_Generator(EMF_Generator emF_Generator, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(emF_Generator, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateUseit_Generator(Useit_Generator useit_Generator, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(useit_Generator, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateTopcasedGenerator(TopcasedGenerator topcasedGenerator, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(topcasedGenerator, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(topcasedGenerator, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(topcasedGenerator, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(topcasedGenerator, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(topcasedGenerator, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(topcasedGenerator, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(topcasedGenerator, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateTopcasedGenerator_isEditorConfig(topcasedGenerator, diagnostics, context);
		return result;
	}

	/**
	 * Validates the isEditorConfig constraint of '<em>Topcased Generator</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateTopcasedGenerator_isEditorConfig(TopcasedGenerator topcasedGenerator,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		// TODO implement the constraint
		// -> specify the condition that violates the constraint
		// -> verify the diagnostic details, including severity, code, and
		// message
		// Ensure that you remove @generated or mark it @generated NOT
		if (false) {
			if (diagnostics != null) {
				diagnostics.add(createDiagnostic(Diagnostic.ERROR, DIAGNOSTIC_SOURCE, 0,
						"_UI_GenericConstraint_diagnostic", new Object[] { "isEditorConfig",
								getObjectLabel(topcasedGenerator, context) }, new Object[] { topcasedGenerator },
						context));
			}
			return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateMMAlias(MMAlias mmAlias, DiagnosticChain diagnostics, Map<Object, Object> context) {
		boolean result = validate_EveryMultiplicityConforms(mmAlias, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(mmAlias, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(mmAlias, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(mmAlias, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(mmAlias, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(mmAlias, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(mmAlias, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateMM_isUriValid(mmAlias, diagnostics, context);
		if (result || diagnostics != null)
			result &= validateMM_isNameSet(mmAlias, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateDocumentable(Documentable documentable, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(documentable, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateComment(Comment comment, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(comment, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateAM3_Generator(AM3_Generator am3_Generator, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(am3_Generator, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateCallable(Callable callable, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(callable, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateGMF_Generator(GMF_Generator gmF_Generator, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(gmF_Generator, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateGeneric_Generator(Generic_Generator generic_Generator, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(generic_Generator, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateMMhandler(MMhandler mMhandler, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateTCGeneratorKind(TCGeneratorKind tcGeneratorKind, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateEMFGeneratorKind(EMFGeneratorKind emfGeneratorKind, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateAM3GeneratorKind(AM3GeneratorKind am3GeneratorKind, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return true;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean validateGMFGeneratorKind(GMFGeneratorKind gmfGeneratorKind, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return true;
	}

	/**
	 * Returns the resource locator that will be used to fetch messages for this
	 * validator's diagnostics. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		// TODO
		// Specialize this to return a resource locator for messages specific to
		// this validator.
		// Ensure that you remove @generated or mark it @generated NOT
		return super.getResourceLocator();
	}

	private static boolean fileNameToURLValid(String filePath) {
		if (filePath == null)
			return false;
		try {
			if (filePath.startsWith("uri:")) {
				return true;
			}

			if (filePath.startsWith("ext:")) {
				File f = new File(filePath.substring(4));
				f.toURL();
				return true;
			}

			IWorkspace wks = ResourcesPlugin.getWorkspace();
			IWorkspaceRoot wksroot = wks.getRoot();

			IFile currentLib = wksroot.getFile(new Path(filePath));
			if (currentLib == null)
				return false;
			if (currentLib.getLocation() == null)
				return false;

			currentLib.getLocation().toFile().toURL();
			return true;
		} catch (MalformedURLException e) {
			return false;
		}

	}

	/**
	 * From the path of an ATL File, this method returns the ASM File
	 * corresponding to the ATL File
	 * 
	 * @param atlFilePath
	 *            name of the ATL File
	 * @return ASM File corresponding to the ATL File
	 */
	private static boolean isASMFileValid(String atlFilePath) {
		if (atlFilePath == null)
			return false;

		IFile currentAtlFile = ResourcesPlugin.getWorkspace().getRoot().getFile(Path.fromOSString(atlFilePath));

		String extension = currentAtlFile.getFileExtension().toLowerCase();
		if (EXTENSIONS.contains(extension)) {
			String currentAsmPath = currentAtlFile.getFullPath().toString().substring(0,
					currentAtlFile.getFullPath().toString().length() - extension.length())
					+ "asm";
			IFile file = ResourcesPlugin.getWorkspace().getRoot().getFile(new Path(currentAsmPath));
			if (file == null)
				return false;
			if (file.getLocation() == null)
				return false;

			URL asmUrl;
			try {
				asmUrl = file.getLocation().toFile().toURL();
				return true;
			} catch (MalformedURLException e) {
				return false;
			}

		}

		return false;
	}

	/**
	 * 
	 * @param atlFile
	 * @return
	 */
	private String toASMresource(String atlFile) {
		String currentAsmPath = atlFile.substring(0, atlFile.length() - 3) + "asm";
		return currentAsmPath;
	}

	private boolean atlFileExist(String atlFilePath) {
		if (atlFilePath == null)
			return false;

		IFile currentAtlFile = ResourcesPlugin.getWorkspace().getRoot().getFile(Path.fromOSString(atlFilePath));

		String extension = currentAtlFile.getFileExtension().toLowerCase();
		if (EXTENSIONS.contains(extension)) {
			String currentAsmPath = currentAtlFile.getFullPath().toString().substring(0,
					currentAtlFile.getFullPath().toString().length() - extension.length())
					+ "asm";
			return asmFileExist(currentAsmPath);
		}

		return false;
	}

	private boolean asmFileExist(String uri) {
		if (uri == null)
			return false;

		uri = toASMresource(uri);

		IFile file = ResourcesPlugin.getWorkspace().getRoot().getFile(new Path(uri));
		if (!file.getFileExtension().equals("asm"))
			return false;

		return file.exists();

	}

	private boolean fileExist(String filePath) {
		if (filePath == null)
			return false;

		IFile currentAtlFile = ResourcesPlugin.getWorkspace().getRoot().getFile(Path.fromOSString(filePath));
		return currentAtlFile.exists();
	}

} // CallchainValidator
